Attribute VB_Name = "modCrystalReport"
Option Explicit

'
'               Visual Basic Declarations of crwrap32.DLL
'               =====================================
'
'       File:         crwrap.BAS
'
'
'

'================================================================================
' Constants and Function Definitions for Exporting
'================================================================================
'******************
'** Format Types **
'******************

'Separated Values           (DLL: "uxfsepv.dll")
Private Const crUXFCharSeparatedType% = 100
Private Const crUXFCommaSeparatedType% = 200
Private Const crUXFTabSeparatedType% = 300

'Data Interchange Format    (DLL: "uxfdif.dll")
Private Const crUXFDIFType% = 400

'Record Style Format        (DLL: "uxfrec.dll")
Private Const crUXFRecordType% = 500


'Crystal Report             (DLL: "uxfcr.dll")
Private Const crUXFCrystalReportType% = 0

'RTF                        (DLL: "uxfrtf.dll")
Private Const crUXFRichTextFormatType% = 0

'Text                       (DLL: "uxftext.dll")
Private Const crUXFTextType% = 0
Private Const crUXFTabbedTextType% = 1
Private Const crUXFPaginatedTextType% = 600

'Lotus                      (DLL: "uxfwks.dll")
Private Const crUXFLotusWksType% = 0  ' Lotus 123 (WKS)
Private Const crUXFLotusWk1Type% = 1  ' Lotus 123(WK1)
Private Const crUXFLotusWk3Type% = 2

'Word for Windows           (DLL: "uxfwordw.dll")
Private Const crUXFWordWinType% = 0

'Excel                      (DLL: "uxfxls.dll")
Private Const crUXFXls5Type% = 3
Private Const crUXFXls5TypeTab% = 700

'Report Definition          (DLL: "uxfrdef.dll")
Private Const crUXFReportDefinitionType = 0

'****************
'** HTML Types **
'****************

'HTML
Private Const crUXFExplorer2Type% = 1              ' Include MS Explorer 2.0 tags
Private Const crUXFNetscape2Type% = 2              ' Include Netscape 2.0 tags
Private Const crUXFHTML32ExtType% = 1              ' HTML 3.2 tags + bg color extensions
Private Const crUXFHTML32StdType% = 2              ' HTML 3.2 tags

'/* field selection bits */
Private Const DM_ORIENTATION = &H1
Private Const DM_PAPERSIZE = &H2
Private Const DM_PAPERLENGTH = &H4
Private Const DM_PAPERWIDTH = &H8
Private Const DM_SCALE = &H10
Private Const DM_COPIES = &H100
Private Const DM_DEFAULTSOURCE = &H200
Private Const DM_PRINTQUALITY = &H400
Private Const DM_COLOR = &H800
Private Const DM_DUPLEX = &H1000
Private Const DM_YRESOLUTION = &H2000
Private Const DM_TTOPTION = &H4000

'/* orientation selections */
Private Const DMORIENT_PORTRAIT = 1
Private Const DMORIENT_LANDSCAPE = 2

'/* paper selections */
'/*  Warning: The PostScript driver mistakingly uses DMPAPER_ values between
' *  50 and 56.  Don't use this range when defining new paper sizes.
' */
Private Const DMPAPER_FIRST = 1
Private Const DMPAPER_LETTER = 1                '/* Letter 8 1/2 x 11 in               */
Private Const DMPAPER_LETTERSMALL = 2           '/* Letter Small 8 1/2 x 11 in         */
Private Const DMPAPER_TABLOID = 3               '/* Tabloid 11 x 17 in                 */
Private Const DMPAPER_LEDGER = 4                '/* Ledger 17 x 11 in                  */
Private Const DMPAPER_LEGAL = 5                 '/* Legal 8 1/2 x 14 in                */
Private Const DMPAPER_STATEMENT = 6             '/* Statement 5 1/2 x 8 1/2 in         */
Private Const DMPAPER_EXECUTIVE = 7             '/* Executive 7 1/4 x 10 1/2 in        */
Private Const DMPAPER_A3 = 8                    '/* A3 297 x 420 mm                    */
Private Const DMPAPER_A4 = 9                    '/* A4 210 x 297 mm                    */
Private Const DMPAPER_A4SMALL = 10              '/* A4 Small 210 x 297 mm              */
Private Const DMPAPER_A5 = 11                   '/* A5 148 x 210 mm                    */
Private Const DMPAPER_B4 = 12                   '/* B4 250 x 354                       */
Private Const DMPAPER_B5 = 13                   '/* B5 182 x 257 mm                    */
Private Const DMPAPER_FOLIO = 14                '/* Folio 8 1/2 x 13 in                */
Private Const DMPAPER_QUARTO = 15               '/* Quarto 215 x 275 mm                */
Private Const DMPAPER_10X14 = 16                '/* 10x14 in                           */
Private Const DMPAPER_11X17 = 17                '/* 11x17 in                           */
Private Const DMPAPER_NOTE = 18                 '/* Note 8 1/2 x 11 in                 */
Private Const DMPAPER_ENV_9 = 19                '/* Envelope #9 3 7/8 x 8 7/8          */
Private Const DMPAPER_ENV_10 = 20               '/* Envelope #10 4 1/8 x 9 1/2         */
Private Const DMPAPER_ENV_11 = 21               '/* Envelope #11 4 1/2 x 10 3/8        */
Private Const DMPAPER_ENV_12 = 22               '/* Envelope #12 4 \276 x 11           */
Private Const DMPAPER_ENV_14 = 23               '/* Envelope #14 5 x 11 1/2            */
Private Const DMPAPER_CSHEET = 24               '/* C size sheet                       */
Private Const DMPAPER_DSHEET = 25               '/* D size sheet                       */
Private Const DMPAPER_ESHEET = 26               '/* E size sheet                       */
Private Const DMPAPER_ENV_DL = 27               '/* Envelope DL 110 x 220mm            */
Private Const DMPAPER_ENV_C5 = 28               '/* Envelope C5 162 x 229 mm           */
Private Const DMPAPER_ENV_C3 = 29               '/* Envelope C3  324 x 458 mm          */
Private Const DMPAPER_ENV_C4 = 30               '/* Envelope C4  229 x 324 mm          */
Private Const DMPAPER_ENV_C6 = 31               '/* Envelope C6  114 x 162 mm          */
Private Const DMPAPER_ENV_C65 = 32              '/* Envelope C65 114 x 229 mm          */
Private Const DMPAPER_ENV_B4 = 33               '/* Envelope B4  250 x 353 mm          */
Private Const DMPAPER_ENV_B5 = 34               '/* Envelope B5  176 x 250 mm          */
Private Const DMPAPER_ENV_B6 = 35               '/* Envelope B6  176 x 125 mm          */
Private Const DMPAPER_ENV_ITALY = 36            '/* Envelope 110 x 230 mm              */
Private Const DMPAPER_ENV_MONARCH = 37          '/* Envelope Monarch 3.875 x 7.5 in    */
Private Const DMPAPER_ENV_PERSONAL = 38         '/* 6 3/4 Envelope 3 5/8 x 6 1/2 in    */
Private Const DMPAPER_FANFOLD_US = 39           '/* US Std Fanfold 14 7/8 x 11 in      */
Private Const DMPAPER_FANFOLD_STD_GERMAN = 40   '/* German Std Fanfold 8 1/2 x 12 in   */
Private Const DMPAPER_FANFOLD_LGL_GERMAN = 41   '/* German Legal Fanfold 8 1/2 x 13 in */

Private Const DMPAPER_LAST = DMPAPER_FANFOLD_LGL_GERMAN

Private Const DMPAPER_USER = 256

'/* bin selections */
Private Const DMBIN_FIRST = 1
Private Const DMBIN_UPPER = 1
Private Const DMBIN_ONLYONE = 1
Private Const DMBIN_LOWER = 2
Private Const DMBIN_MIDDLE = 3
Private Const DMBIN_MANUAL = 4
Private Const DMBIN_ENVELOPE = 5
Private Const DMBIN_ENVMANUAL = 6
Private Const DMBIN_AUTO = 7
Private Const DMBIN_TRACTOR = 8
Private Const DMBIN_SMALLFMT = 9
Private Const DMBIN_LARGEFMT = 10
Private Const DMBIN_LARGECAPACITY = 11
Private Const DMBIN_CASSETTE = 14
Private Const DMBIN_LAST = DMBIN_CASSETTE

Private Const DMBIN_USER = 256              '/* device specific bins start here */

'/* print qualities */
Private Const DMRES_DRAFT = -1
Private Const DMRES_LOW = -2
Private Const DMRES_MEDIUM = -3
Private Const DMRES_HIGH = -4

'/* color enable/disable for color printers */
Private Const DMCOLOR_MONOCHROME = 1
Private Const DMCOLOR_COLOR = 2

'/* duplex enable */
Private Const DMDUP_SIMPLEX = 1
Private Const DMDUP_VERTICAL = 2
Private Const DMDUP_HORIZONTAL = 3

'/* TrueType options */
Private Const DMTT_BITMAP = 1           '/* print TT fonts as graphics */
Private Const DMTT_DOWNLOAD = 2         '/* download TT fonts as soft fonts */
Private Const DMTT_SUBDEV = 3           '/* substitute device fonts for TT fonts */

Private Const PE_SIZEOF_SESSION_INFO4 = 262   ' # bytes in PESessionInfo
Private Const PE_SIZEOF_TABLE_TYPE4 = 644


'Window Style Constants
Private Const WS_MINIMIZE = 536870912  'Make a window of minimum size.
Private Const WS_VISIBLE = 268435456  'Make a window that is visible when it first
                      'appears (for overlapping and pop-up windows).
Private Const WS_DISABLED = 134217728  'Make a window that is disabled when it first appears.
Private Const WS_CLIPSIBLINGS = 67108864  'Clip child windows with respect to one another.
Private Const WS_CLIPCHILDREN = 33554432  'Exclude the area occupied by child windows when drawing inside the parent window.
Private Const WS_MAXIMIZE = 16777216  'Make a window of maximum size.
Private Const WS_CAPTION = 12582912  'Make a window that includes a title bar.
Private Const WS_BORDER = 8388608  'Make a window that includes a border.
Private Const WS_DLGFRAME = 4194304  'Make a window that has a double border but no title.
Private Const WS_VSCROLL = 2097152  'Make a window that includes a vertical scroll bar.
Private Const WS_HSCROLL = 1048576  'Make a window that includes a horizontal scroll bar.
Private Const WS_SYSMENU = 524288  'Include the system menu box.
Private Const WS_THICKFRAME = 262144  'Include the thick frame that can be used to size the window.
Private Const WS_MINIMIZEBOX = 131072  'Include the minimize box.
Private Const WS_MAXIMIZEBOX = 65536  'Include the maximize box.
Private Const CW_USEDFAULT = -32768  ' Assign the child window the default
                    ' horizontal and vertical position, and the
                    ' default height and width.



'DateTime structure
Private Type crDateTime
    crDate As Long
    crTime As Long
End Type


'Devmode structure
Private Type crDEVMODE
    dmDriverVersion As Integer  ' printer driver version number (usually not required)
    dmFields As Long           'flags indicating fields to modify (required)
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
End Type
'================================================================================
' Type Declarations for 4-byte aligned functions
'================================================================================
Private Type PEJobInfo4
    StructSize As Integer  ' initialize to PE_SIZEOF_JOB_INFO

    NumRecordsRead As Long
    NumRecordsSelected As Long
    NumRecordsPrinted As Long

    DisplayPageN As Integer
    LatestPageN As Integer
    StartPageN As Integer

    PrintEnded As Long
End Type
Private Const PE_SIZEOF_JOB_INFO4 = 28

Private Type PETableType4
    StructSize As Integer   ' initialize to # bytes in PETableType

    DLLName As String * 64 'PE_DLL_NAME_LEN
    DescriptiveName  As String * 256 'PE_FULL_NAME_LEN

    DBType As Integer
End Type


Private Type PELogOnInfo4
    ' initialize to # bytes in PELogOnInfo
    StructSize As Integer

    ' For any of the following values an empty string ("") means to use
    ' the value already set in the report.  To override a value in the
    ' report use a non-empty string (e.g. "Server A").
    '
    ' For Netware SQL, pass the dictionary path name in ServerName and
    ' data path name in DatabaseName.

    ServerName As String * 128 'PE_SERVERNAME_LEN
    DatabaseName  As String * 128 'PE_DATABASENAME_LEN
    UserID As String * 128 'PE_USERID_LEN

    ' Password is undefined when getting information from report.

    Password  As String * 128 'PE_PASSWORD_LEN
End Type
Private Const PE_SIZEOF_LOGON_INFO4 = 514   ' # bytes in PELogOnInfo


Private Type PESessionInfo4
    'initialize to # bytes in PESessionInfo
    StructSize As Integer

    ' Password is undefined when getting information from report.
    UserID As String * 128 'PE_SESS_USERID_LEN
    Password As String * 128 'PE_SESS_PASSWORD_LEN

    ' SessionHandle is undefined when getting information from report.
    ' When setting information, if it is = 0 the UserID and Password
    ' settings are used, otherwise the SessionHandle is used.
    SessionHandle As Long
End Type

Private Type PEGraphOptions4
    StructSize     As Integer  ' initialize to # bytes in PEGraphOptions
    GraphMaxValue  As Double
    GraphMinValue  As Double
    ShowDataValue  As Long  ' Show data values on risers.
    ShowGridLine   As Long
    VerticalBars   As Long
    ShowLegend     As Long
    FontFaceName   As String * 128 'PE_GRAPH_TEXT_LEN
End Type
Private Const PE_SIZEOF_GRAPH_OPTIONS4 = 2 + 2 * 8 + 4 * 4 + 128  'PE_GRAPH_TEXT_LEN 'PE_WORD_LEN


'================================================================================
' Function Declarations
'================================================================================

'    '** new CRPE wrapper Functions
'Private Declare Function crPELogOnServer Lib "crwrap32.dll" (ByVal DLLName$, ByVal ServerName$, ByVal DBName$, ByVal UserID$, ByVal Password$) As Integer
'Private Declare Function crPELogOffServer Lib "crwrap32.dll" (ByVal DLLName$, ByVal ServerName$, ByVal DBName$, ByVal UserID$, ByVal Password$) As Integer
'Private Declare Function crPESetNthTableLogOnInfo Lib "crwrap32.dll" (ByVal printJob%, ByVal TableN%, ByVal ServerName$, ByVal DBName$, ByVal UserID$, ByVal Password$, ByVal PropagateAcrossTables As Long) As Integer
'Private Declare Function crPEGetNthTableLogOnInfo Lib "crwrap32.dll" Alias "crvbPEGetNthTableLogOnInfo" (ByVal printJob%, ByVal TableN%, ByRef ServerName$, ByRef DBName$, ByRef UserID$) As Integer
'Private Declare Function crPESetNthTableLocation Lib "crwrap32.dll" (ByVal printJob%, ByVal TableN%, ByVal tableLocation$) As Integer
'Private Declare Function crPEGetNthTableLocation Lib "crwrap32.dll" Alias "crvbPEGetNthTableLocation" (ByVal printJob%, ByVal TableN%, ByRef tableLocation$) As Integer
'Private Declare Function crPEGetSelectedPrinter Lib "crwrap32.dll" Alias "crvbPEGetSelectedPrinter" (ByVal printJob%, ByRef DriverName$, ByRef PrinterName$, ByRef PortName$, crmode As crDEVMODE) As Integer
'Private Declare Function crPESelectPrinter Lib "crwrap32.dll" (ByVal printJob%, ByVal DriverName$, ByVal PrinterName$, ByVal PortName$, crmode As crDEVMODE) As Integer
'Private Declare Function crPESetNthTableSessionInfo Lib "crwrap32.dll" (ByVal printJob%, ByVal TableN%, ByVal UserID$, ByVal Password$, ByVal SessionHandle As Long, ByVal PropagateAcrossTables As Long) As Integer
'Private Declare Function crPEGetNthTableSessionInfo Lib "crwrap32.dll" Alias "crvbPEGetNthTableSessionInfo" (ByVal printJob%, ByVal TableN%, ByRef UserID$, ByRef SessionHandle As Long) As Integer
'Private Declare Function crPESetGraphOptions Lib "crwrap32.dll" (ByVal printJob%, ByVal sectionCode%, ByVal GraphN%, ByVal GraphMaxValue As Double, ByVal GraphMinValue As Double, ByVal ShowDataValue As Long, ByVal ShowGridLine As Long, ByVal VerticalBars As Long, ByVal ShowLegend As Long, ByVal FontFaceName$) As Integer
'Private Declare Function crPEGetGraphOptions Lib "crwrap32.dll" Alias "crvbPEGetGraphOptions" (ByVal printJob%, ByVal sectionCode%, ByVal GraphN%, ByRef GraphMaxValue As Double, ByRef GraphMinValue As Double, ByRef ShowDataValue As Long, ByRef ShowGridLine As Long, ByRef VerticalBars As Long, ByRef ShowLegend As Long, ByRef FontFaceName$) As Integer
'Private Declare Function crPEGetNthParameterType Lib "crwrap32.dll" (ByVal printJob%, ByVal parameterN%) As Integer
'Private Declare Function crPEGetNthParameterField Lib "crwrap32.dll" Alias "crvbPEGetNthParameterField" (ByVal printJob%, ByVal parameterN%, ByRef valueType%, ByRef DefaultValueSet%, ByRef CurrentValueSet%, ByRef Name$, ByRef Prompt$, ByRef DefaultValue As Any, ByRef currentValue As Any) As Integer
'Private Declare Function crPESetNthParameterField Lib "crwrap32.dll" (ByVal printJob%, ByVal parameterN%, ByVal valueType%, ByVal DefaultValueSet%, ByVal CurrentValueSet%, ByVal Name$, ByVal Prompt$, ByRef DefaultValue As Any, ByRef currentValue As Any) As Integer
'
'Private Declare Function crvbHandleToBStr Lib "crwrap32.dll" (ByRef BString$, ByVal strHandle As Long, ByVal strLength%) As Integer
'Private Declare Function crPEYearMonthDayToDate Lib "crwrap32.dll" (ByVal nYear%, ByVal nMonth%, ByVal nDay%) As Long
'Private Declare Function crPEDateToYearMonthDay Lib "crwrap32.dll" (ByVal nDate As Long, ByRef nYear%, ByRef nMonth%, ByRef nDay%) As Integer
'Private Declare Function crPEHourMinuteSecondToTime Lib "crwrap32.dll" (ByVal nHour%, ByVal nMinute%, ByVal nSecond%) As Long
'Private Declare Function crTimeToHourMinuteSecond Lib "crwrap32.dll" (ByVal nTime As Long, ByRef nHour%, ByRef nMinute%, ByRef nSecond%) As Integer
'
'    '** Export Functions **
'Private Declare Function crPEExportToApp Lib "crwrap32.dll" (ByVal printJob%, ByVal FileName$, ByVal FormatDLLName$, ByVal FormatType As Long, ByVal useNumFormat As Long, ByVal useDateFormat As Long, ByVal StringDelimiter$, ByVal FieldDelimiter$) As Integer
'Private Declare Function crPEExportToDisk Lib "crwrap32.dll" (ByVal printJob%, ByVal FileName$, ByVal FormatDLLName$, ByVal FormatType As Long, ByVal useNumFormat As Long, ByVal useDateFormat As Long, ByVal StringDelimiter$, ByVal FieldDelimiter$) As Integer
'Private Declare Function crPEExportToMapi Lib "crwrap32.dll" (ByVal printJob%, ByVal toList$, ByVal ccList$, ByVal subject$, ByVal message$, ByVal FormatDLLName$, ByVal FormatType As Long, ByVal useNumFormat As Long, ByVal useDateFormat As Long, ByVal StringDelimiter$, ByVal FieldDelimiter$) As Integer
'Private Declare Function crPEExportToExch Lib "crwrap32.dll" (ByVal printJob%, ByVal profile$, ByVal Password$, ByVal folderPath$, ByVal FormatDLLName$, ByVal FormatType As Long, ByVal useNumFormat As Long, ByVal useDateFormat As Long, ByVal StringDelimiter$, ByVal FieldDelimiter$) As Integer
'Private Declare Function crPEExportToODBC Lib "crwrap32.dll" (ByVal printJob%, ByVal DataSourceName$, ByVal dataSourceUserID$, ByVal dataSourcePassword$, ByVal exportTableName$) As Integer
'Private Declare Function crPEExportToHTML Lib "crwrap32.dll" (ByVal printJob%, ByVal htmlType%, ByVal FileName$) As Integer
'Private Declare Function crPEExportToVIM Lib "crwrap32.dll" (ByVal printJob%, ByVal toList$, ByVal ccList$, ByVal bccList$, ByVal subject$, ByVal message$, ByVal FormatDLLName$, ByVal FormatType As Long, ByVal useNumFormat As Long, ByVal useDateFormat As Long, ByVal StringDelimiter$, ByVal FieldDelimiter$) As Integer
'Private Declare Function crPEExportToNotes Lib "crwrap32.dll" (ByVal printJob%, ByVal DBName$, ByVal FormName$, ByVal comments$, ByVal FormatDLLName$, ByVal FormatType As Long, ByVal useNumFormat As Long, ByVal useDateFormat As Long, ByVal StringDelimiter$, ByVal FieldDelimiter$) As Integer
'
'    '** Functions which accept VB's native 4-byte aligned "Types"
'Private Declare Function PEGetJobStatus4 Lib "crwrap32.dll" (ByVal printJob%, JobInfo As PEJobInfo4) As Integer
'Private Declare Function PEGetNthTableType4 Lib "crwrap32.dll" (ByVal printJob%, ByVal TableN%, TableType As PETableType4) As Integer
'Private Declare Function PELogOnServer4 Lib "crwrap32.dll" (ByVal DLLName$, LogOnInfo As PELogOnInfo4) As Integer
'Private Declare Function PELogOffServer4 Lib "crwrap32.dll" (ByVal DLLName$, LogOnInfo As PELogOnInfo4) As Integer
'Private Declare Function PESetNthTableSessionInfo4 Lib "crwrap32.dll" (ByVal printJob%, ByVal TableN%, SessionInfo As PESessionInfo4, ByVal PropagateAcrossTables As Long) As Integer
'Private Declare Function PEGetNthTableSessionInfo4 Lib "crwrap32.dll" (ByVal printJob%, ByVal TableN%, SessionInfo As PESessionInfo4) As Integer
'Private Declare Function PESetGraphOptions4 Lib "crwrap32.dll" (ByVal printJob%, ByVal sectionCode%, ByVal GraphN%, GraphOptions As PEGraphOptions4) As Integer
'Private Declare Function PEGetGraphOptions4 Lib "crwrap32.dll" (ByVal printJob%, ByVal sectionCode%, ByVal GraphN%, GraphOptions As PEGraphOptions4) As Integer


Private Const PE_UNCHANGED_COLOR = -2

Private Const PE_ERR_NOERROR = 0

Private Const PE_ERR_NOTENOUGHMEMORY = 500
Private Const PE_ERR_INVALIDJOBNO = 501
Private Const PE_ERR_INVALIDHANDLE = 502
Private Const PE_ERR_STRINGTOOLONG = 503
Private Const PE_ERR_NOSUCHREPORT = 504
Private Const PE_ERR_NODESTINATION = 505
Private Const PE_ERR_BADFILENUMBER = 506
Private Const PE_ERR_BADFILENAME = 507
Private Const PE_ERR_BADFIELDNUMBER = 508
Private Const PE_ERR_BADFIELDNAME = 509
Private Const PE_ERR_BADFORMULANAME = 510
Private Const PE_ERR_BADSORTDIRECTION = 511
Private Const PE_ERR_ENGINENOTOPEN = 512
Private Const PE_ERR_INVALIDPRINTER = 513
Private Const PE_ERR_PRINTFILEEXISTS = 514
Private Const PE_ERR_BADFORMULATEXT = 515
Private Const PE_ERR_BADGROUPSECTION = 516
Private Const PE_ERR_ENGINEBUSY = 517
Private Const PE_ERR_BADSECTION = 518
Private Const PE_ERR_NOPRINTWINDOW = 519
Private Const PE_ERR_JOBALREADYSTARTED = 520
Private Const PE_ERR_BADSUMMARYFIELD = 521
Private Const PE_ERR_NOTENOUGHSYSRES = 522
Private Const PE_ERR_BADGROUPCONDITION = 523
Private Const PE_ERR_JOBBUSY = 524
Private Const PE_ERR_BADREPORTFILE = 525
Private Const PE_ERR_NODEFAULTPRINTER = 526
Private Const PE_ERR_SQLSERVERERROR = 527
Private Const PE_ERR_BADLINENUMBER = 528
Private Const PE_ERR_DISKFULL = 529
Private Const PE_ERR_FILEERROR = 530
Private Const PE_ERR_INCORRECTPASSWORD = 531
Private Const PE_ERR_BADDATABASEDLL = 532
Private Const PE_ERR_BADDATABASEFILE = 533
Private Const PE_ERR_ERRORINDATABASEDLL = 534
Private Const PE_ERR_DATABASESESSION = 535
Private Const PE_ERR_DATABASELOGON = 536
Private Const PE_ERR_DATABASELOCATION = 537
Private Const PE_ERR_BADSTRUCTSIZE = 538
Private Const PE_ERR_BADDATE = 539
Private Const PE_ERR_BADEXPORTDLL = 540
Private Const PE_ERR_ERRORINEXPORTDLL = 541
Private Const PE_ERR_PREVATFIRSTPAGE = 542
Private Const PE_ERR_NEXTATLASTPAGE = 543
Private Const PE_ERR_CANNOTACCESSREPORT = 544
Private Const PE_ERR_USERCANCELLED = 545
Private Const PE_ERR_OLE2NOTLOADED = 546
Private Const PE_ERR_BADCROSSTABGROUP = 547
Private Const PE_ERR_NOCTSUMMARIZEDFIELD = 548
Private Const PE_ERR_DESTINATIONNOTEXPORT = 549
Private Const PE_ERR_INVALIDPAGENUMBER = 550
Private Const PE_ERR_NOTSTOREDPROCEDURE = 552
Private Const PE_ERR_INVALIDPARAMETER = 553
Private Const PE_ERR_GRAPHNOTFOUND = 554
Private Const PE_ERR_INVALIDGRAPHTYPE = 555
Private Const PE_ERR_INVALIDGRAPHDATA = 556
Private Const PE_ERR_CANNOTMOVEGRAPH = 557
Private Const PE_ERR_INVALIDGRAPHTEXT = 558
Private Const PE_ERR_INVALIDGRAPHOPT = 559

'New Error Codes For 5.0
Private Const PE_ERR_BADSECTIONHEIGHT = 560
Private Const PE_ERR_BADVALUETYPE = 561
Private Const PE_ERR_INVALIDSUBREPORTNAME = 562
Private Const PE_ERR_NOPARENTWINDOW = 564      'dialog parent window
Private Const PE_ERR_INVALIDZOOMFACTOR = 565   'zoom factor
Private Const PE_ERR_PAGESIZEOVERFLOW = 567
Private Const PE_ERR_LOWSYSTEMRESOURCES = 568
Private Const PE_ERR_BADGROUPNUMBER = 570
Private Const PE_ERR_INVALIDNEGATIVEVALUE = 572
Private Const PE_ERR_INVALIDMEMORYPOINTER = 573
Private Const PE_ERR_INVALIDPARAMETERNUMBER = 594
Private Const PE_ERR_SQLSERVERNOTOPENED = 599

Private Const PE_ERR_NOTIMPLEMENTED = 999

'new constants for 7.0
Private Const PE_ERR_INVALIDOBJECTFORMATNAME = 571
Private Const PE_ERR_INVALIDOBJECTTYPE = 574
Private Const PE_ERR_INVALIDGRAPHDATATYPE = 577
Private Const PE_ERR_INVALIDSUBREPORTLINKNUMBER = 582
Private Const PE_ERR_SUBREPORTLINKEXIST = 583
Private Const PE_ERR_BADROWCOLVALUE = 584
Private Const PE_ERR_INVALIDSUMMARYNUMBER = 585
Private Const PE_ERR_INVALIDGRAPHDATAFIELDNUMBER = 586
Private Const PE_ERR_INVALIDSUBREPORTNUMBER = 587
Private Const PE_ERR_INVALIDFIELDSCOPE = 588
Private Const PE_ERR_FIELDINUSE = 590
Private Const PE_ERR_INVALIDPAGEMARGINS = 595
Private Const PE_ERR_REPORTONSECUREQUERY = 596
Private Const PE_ERR_CANNOTOPENSECUREQUERY = 597
Private Const PE_ERR_INVALIDSECTIONNUMBER = 598
Private Const PE_ERR_TABLENAMEEXIST = 606
Private Const PE_ERR_INVALIDCURSOR = 607
Private Const PE_ERR_FIRSTPASSNOTFINISHED = 608
Private Const PE_ERR_CREATEDATASOURCE = 609
Private Const PE_ERR_CREATEDRILLDOWNPARAMETERS = 610
Private Const PE_ERR_CHECKFORDATASOURCECHANGES = 613
Private Const PE_ERR_STARTBACKGROUNDPROCESSING = 614
Private Const PE_ERR_SQLSERVERINUSE = 619
Private Const PE_ERR_GROUPSORTFIELDNOTSET = 620
Private Const PE_ERR_CANNOTSETSAVESUMMARIES = 621
Private Const PE_ERR_LOADOLAPDATABASEMANAGER = 622
Private Const PE_ERR_OPENOLAPCUBE = 623
Private Const PE_ERR_READOLAPCUBEDATA = 624
Private Const PE_ERR_CANNOTSAVEQUERY = 626
Private Const PE_ERR_CANNOTREADQUERYDATA = 627
Private Const PE_ERR_MAINREPORTFIELDLINKED = 629
Private Const PE_ERR_INVALIDMAPPINGTYPEVALUE = 630
Private Const PE_ERR_HITTESTFAILED = 636
Private Const PE_ERR_BADSQLEXPRESSIONNAME = 637         ' no SQL expression by the specified *name* exists in this report.
Private Const PE_ERR_BADSQLEXPRESSIONNUMBER = 638       ' no SQL expression by the specified *number* exists in this report.
Private Const PE_ERR_BADSQLEXPRESSIONTEXT = 639         ' not a valid SQL expression
Private Const PE_ERR_INVALIDDEFAULTVALUEINDEX = 641     ' invalid index for default value of a parameter.
Private Const PE_ERR_NOMINMAXVALUE = 642                ' the specified PE_PF_* type does not have min/max values.
Private Const PE_ERR_INCONSISTANTTYPES = 643            ' if both min and max values are specified in PESetParameterMinMaxValue,
                                                      ' the value types for the min and max must be the same.
Private Const PE_ERR_CANNOTLINKTABLES = 645
Private Const PE_ERR_CREATEROUTER = 646
Private Const PE_ERR_INVALIDFIELDINDEX = 647
Private Const PE_ERR_INVALIDGRAPHTITLETYPE = 648
Private Const PE_ERR_INVALIDGRAPHTITLEFONTTYPE = 649

'end new for 7.0 section

' new consts for 7.0, MR1
Private Const PE_ERR_PARAMTYPEDIFFERENT = 650  ' the type used in a add/set value API for a
                                             ' parameter differs with it's existing type.
Private Const PE_ERR_INCONSISTANTRANGETYPES = 651  ' the value type for both start & end range
                                                 ' values must be the same.
Private Const PE_ERR_RANGEORDISCRETE = 652        ' an operation was attempted on a discrete parameter that is
                                                ' only legal for range parameters or vice versa.

Private Const PE_ERR_NOTMAINREPORT = 654          ' an operation was attempted that is disallowed for subreports.

Private Const PE_ERR_INVALIDCURRENTVALUEINDEX = 655  ' invalid index for current value of a parameter.
Private Const PE_ERR_LINKEDPARAMVALUE = 656  ' operation illegal on linked parameter.

Private Const PE_ERR_INVALIDPARAMETERRANGEINFO = 672  ' Invalid PE_RI_* combination.

Private Const PE_ERR_INVALIDSORTMETHODINDEX = 674  ' Invalid sort method index.

Private Const PE_ERR_INVALIDGRAPHSUBTYPE = 675    ' Invalid PE_GST_* or
                                                ' PE_GST_* does not match PE_GT_* or
                                                ' PE_GST_* current graph type.
Private Const PE_ERR_BADGRAPHOPTIONINFO = 676     ' one of them members of PEGraphOptionInfo is out of range.
Private Const PE_ERR_BADGRAPHAXISINFO = 677       ' one of them members of PEGraphAxisInfo is out of range.

Private Const PE_ERR_NOTEXTERNALSUBREPORT = 680   ' the subreport is not imported.
Private Const PE_ERR_INVALIDPARAMETERVALUE = 687
Private Const PE_ERR_INVALIDFORMULASYNTAXTYPE = 688  ' specified formula syntax not in PE_FST_*
Private Const PE_ERR_INVALIDCROPVALUE = 689
Private Const PE_ERR_INVALIDCOLLATIONVALUE = 690
Private Const PE_ERR_STARTPAGEGREATERSTOPPAGE = 691
Private Const PE_ERR_INVALIDEXPORTFORMAT = 692

Private Const PE_ERR_OTHERERROR = 997
Private Const PE_ERR_INTERNALERROR = 998                ' programming error

'Constants using to calculate structure size constants
Private Const PE_BYTE_LEN = 1
Private Const PE_WORD_LEN = 2
Private Const PE_LONG_LEN = 4
Private Const PE_DOUBLE_LEN = 8

' Open, print and close report (used when no changes needed to report)
' --------------------------------------------------------------------

Declare Function PEPrintReport Lib "crpe32.dll" (ByVal RptName$, ByVal Printer%, ByVal Window%, ByVal Title$, ByVal Lft&, ByVal Top&, ByVal Wdth&, ByVal height&, ByVal style As Long, ByVal PWindow As Long) As Integer


' Open and close print engine
' ---------------------------

Declare Function PEOpenEngine Lib "crpe32.dll" () As Integer
Declare Sub PECloseEngine Lib "crpe32.dll" ()
Declare Function PECanCloseEngine Lib "crpe32.dll" () As Integer


' Get version info
' ----------------

Private Const PE_GV_DLL = 100       ' values for version parameter of PEGetVersion
Private Const PE_GV_ENGINE = 200

Declare Function PEGetVersion Lib "crpe32.dll" (ByVal version%) As Integer


' Open and close print job (i.e. report)
' --------------------------------------

Declare Function PEOpenPrintJob Lib "crpe32.dll" (ByVal RptName$) As Integer

Declare Function PEClosePrintJob Lib "crpe32.dll" (ByVal printJob%) As Integer


' Start and cancel print job (i.e. print the report, usually after changing report)
' ---------------------------------------------------------------------------------

Declare Function PEStartPrintJob Lib "crpe32.dll" (ByVal printJob%, ByVal WaitOrNot%) As Integer

Declare Sub PECancelPrintJob Lib "crpe32.dll" (ByVal printJob%)


' report options
'----------------
Private Const PE_RPTOPT_CVTDATETIMETOSTR = 0
Private Const PE_RPTOPT_CVTDATETIMETODATE = 1
Private Const PE_RPTOPT_KEEPDATETIMETYPE = 2

' Following are the valid values for promptMode
Private Const PE_RPTOPT_PROMPT_NONE = 0
Private Const PE_RPTOPT_PROMPT_NORMAL = 1
Private Const PE_RPTOPT_PROMPT_ALWAYS = 2

Private Type PEReportOptions
    StructSize As Integer                       'initialize to PE_SIZEOF_REPORT_OPTIONS
    saveDataWithReport As Integer               'BOOL value, except use PE_UNCHANGED for no change
    saveSummariesWithReport As Integer          'BOOL value, except use PE_UNCHANGED for no change
    useIndexForSpeed As Integer                 'BOOL value, except use PE_UNCHANGED for no change
    translateDOSStrings As Integer              'BOOL value, except use PE_UNCHANGED for no change
    translateDosMemos As Integer                'BOOL value, except use PE_UNCHANGED for no change
    convertDateTimeType As Integer              'a PE_RPTOPT_ value, except use PE_UNCHANGED for no change
    convertNullFieldToDefault As Integer        'BOOL value, except use PE_UNCHANGED for no change
    morePrintEngineErrorMessages As Integer     'BOOL value, except use PE_UNCHANGED for no change
    caseInsensitiveSQLData As Integer           'BOOL value, except use PE_UNCHANGED for no change
    verifyOnEveryPrint As Integer               'BOOL value, except use PE_UNCHAGED for no change
    zoomMode As Integer                         'a PE_ZOOM_ constant, except use PE_UNCHANGED for no change
    hasGroupTree As Integer                     'BOOL value, except use PE_UNCHANGED for no change
    dontGenerateDataForHiddenObjects As Integer ' BOOL value, except use PE_UNCHANGED for no change
    performGroupingOnServer As Integer          ' BOOL value, except use PE_UNCHANGED for no change
    doAsyncQuery As Integer                     ' BOOL value, except use PE_UNCHANGED for no change
    promptMode As Integer                       ' PE_RPTOPT_PROMPT_NONE, PE_RPTOPT_PROMPT_NORMAL, PE_RPTOPT_PROMPT_ALWAYS, use PE_UNCHANGED for no change
    SelectDistinctRecords As Integer            ' BOOL value, except use PE_UNCHANGED for no change
End Type

Private Const PE_SIZEOF_REPORT_OPTIONS = 18 * PE_WORD_LEN

Private Declare Function PEGetReportOptions Lib "crpe32.dll" (ByVal printJob%, reportOptions As PEReportOptions) As Integer

Private Declare Function PESetReportOptions Lib "crpe32.dll" (ByVal printJob%, reportOptions As PEReportOptions) As Integer


' Print job status
' ----------------
 
Private Declare Function PEIsPrintJobFinished Lib "crpe32.dll" (ByVal printJob%) As Integer

' To work around the problem of 4 - Byte alignment the PEGetJobStatus
' call has been re-declared locally. When your application calls PEGetJobStatus
' it is calling a function in this file which in turn calls CRPE32.DLL.
Private Const PE_JOBNOTSTARTED = 1
Private Const PE_JOBINPROGRESS = 2
Private Const PE_JOBCOMPLETED = 3
Private Const PE_JOBFAILED = 4
Private Const PE_JOBCANCELLED = 5
Private Const PE_JOBHALTED = 6    ' too many records or too much time

Private Type PEJobInfo
    StructSize As Integer  ' initialize to PE_SIZEOF_JOB_INFO

    NumRecordsRead As Long
    NumRecordsSelected As Long
    NumRecordsPrinted As Long

    DisplayPageN As Integer
    LatestPageN As Integer
    StartPageN As Integer

    PrintEnded As Long
End Type

Private Type SplitPEJobInfo
    StructSize As Integer  ' initialize to PE_SIZEOF_JOB_INFO

    NumRecordsRead1 As Integer
    NumRecordsRead2 As Integer
    NumRecordsSelected1 As Integer
    NumRecordsSelected2 As Integer
    NumRecordsPrinted1 As Integer
    NumRecordsPrinted2 As Integer

    DisplayPageN As Integer
    LatestPageN As Integer
    StartPageN As Integer

    PrintEnded As Long
End Type

Private Const PE_SIZEOF_JOB_INFO = 10 * PE_WORD_LEN + 4

Private Declare Function RealPEGetJobStatus Lib "crpe32.dll" Alias "PEGetJobStatus" (ByVal printJob%, JobInfo As SplitPEJobInfo) As Integer

' Controlling dialogs
' -------------------

Private Declare Function PESetDialogParentWindow Lib "crpe32.dll" (ByVal printJob%, ByVal parentWindow As Long) As Integer

Private Declare Function PEEnableProgressDialog Lib "crpe32.dll" (ByVal printJob%, ByVal enable%) As Integer

' Controlling Paremeter Field Prompting Dialog
' --------------------------------------------

' Set boolean to indicate whether CRPE is allowed to prompt for parameter values
' during printing.

Private Declare Function PEGetAllowPromptDialog Lib "crpe32.dll" (ByVal printJob%) As Integer
Private Declare Function PESetAllowPromptDialog Lib "crpe32.dll" (ByVal printJob%, ByVal showPromptDialog%) As Integer


' Print job error codes and messages
' ----------------------------------

Private Declare Function PEGetErrorCode Lib "crpe32.dll" (ByVal printJob%) As Integer

Private Declare Function PEGetErrorText Lib "crpe32.dll" (ByVal printJob%, TextHandle As Long, TextLength%) As Integer

Private Declare Function PEGetHandleString Lib "crpe32.dll" (ByVal TextHandle As Long, ByVal Buffer$, ByVal BufferLength%) As Integer

' Setting the print date
' ----------------------

Private Declare Function PEGetPrintDate Lib "crpe32.dll" (ByVal printJob%, Date_Year%, Date_Month%, Date_Day%) As Integer

Private Declare Function PESetPrintDate Lib "crpe32.dll" (ByVal printJob%, ByVal Date_Year%, ByVal Date_Month%, ByVal Date_Day%) As Integer

' Encoding and Decoding Section Codes
' -----------------------------------

Private Const PE_ALLSECTIONS = 0

'Section types for use with PE_SECTION_CODE, PE_SECTION_TYPE, PE_GROUP_N and PE_SECTION_N functions
Private Const PE_SECT_PAGE_HEADER = 2
Private Const PE_SECT_PAGE_FOOTER = 7
Private Const PE_SECT_REPORT_HEADER = 1
Private Const PE_SECT_REPORT_FOOTER = 8
Private Const PE_SECT_GROUP_HEADER = 3
Private Const PE_SECT_GROUP_FOOTER = 5
Private Const PE_SECT_DETAIL = 4

'The old section constants with comment showing them in terms of the new:
'(Note that PE_GRANDTOTALSECTION and PE_SUMMARYSECTION both map
' to PE_SECT_REPORT_FOOTER.)

Private Const PE_HEADERSECTION = 2000   'PE_SECTION_CODE (PE_SECT_PAGE_HEADER,   0, 0)
Private Const PE_FOOTERSECTION = 7000   'PE_SECTION_CODE (PE_SECT_PAGE_FOOTER,   0, 0)
Private Const PE_TITLESECTION = 1000    'PE_SECTION_CODE (PE_SECT_REPORT_HEADER, 0, 0)
Private Const PE_SUMMARYSECTION = 8000  'PE_SECTION_CODE (PE_SECT_REPORT_FOOTER, 0, 0)
Private Const PE_GROUPHEADER = 3000     'PE_SECTION_CODE (PE_SECT_GROUP_HEADER,  0, 0)
Private Const PE_GROUPFOOTER = 5000     'PE_SECTION_CODE (PE_SECT_GROUP_FOOTER,  0, 0)
Private Const PE_DETAILSECTION = 4000   'PE_SECTION_CODE (PE_SECT_DETAIL,        0, 0)
Private Const PE_GRANDTOTALSECTION = PE_SUMMARYSECTION


' Controlling group conditions (i.e. group breaks)
' ------------------------------------------------
Private Const PE_SF_MAX_NAME_LENGTH = 50

Private Const PE_SF_DESCENDING = 0
Private Const PE_SF_ASCENDING = 1
Private Const PE_SF_ORIGINAL = 2  'only for group condition
Private Const PE_SF_SPECIFIED = 3  'only for group condition

' use PE_ANYCHANGE for all field types except Date
Private Const PE_GC_ANYCHANGE = 0

' use these constants for Date and DateTime fields
Private Const PE_GC_DAILY = 0
Private Const PE_GC_WEEKLY = 1
Private Const PE_GC_BIWEEKLY = 2
Private Const PE_GC_SEMIMONTHLY = 3
Private Const PE_GC_MONTHLY = 4
Private Const PE_GC_QUARTERLY = 5
Private Const PE_GC_SEMIANNUALLY = 6
Private Const PE_GC_ANNUALLY = 7

' use these constants for Time  and DateTime fields
Private Const PE_GC_BYSECOND = 8
Private Const PE_GC_BYMINUTE = 9
Private Const PE_GC_BYHOUR = 10
Private Const PE_GC_BYAMPM = 11

' use these constants for Boolean fields
Private Const PE_GC_TOYES = 1
Private Const PE_GC_TONO = 2
Private Const PE_GC_EVERYYES = 3
Private Const PE_GC_EVERYNO = 4
Private Const PE_GC_NEXTISYES = 5
Private Const PE_GC_NEXTISNO = 6

Private Declare Function PESetGroupCondition Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, ByVal ConditionField$, ByVal condition%, ByVal SortDirection%) As Integer

Private Declare Function PEGetNGroups Lib "crpe32.dll" (ByVal printJob%) As Integer

' for PEGetGroupCondition, Condition% encodes both
' the condition and the type of the condition field
Private Const PE_GC_CONDITIONMASK = &HFF
Private Const PE_GC_TYPEMASK = &HF00

Private Const PE_GC_TYPEOTHER = &H0
Private Const PE_GC_TYPEDATE = &H200
Private Const PE_GC_TYPEBOOLEAN = &H400
Private Const PE_GC_TYPETIME = &H800

Private Declare Function PEGetGroupCondition Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, ConditionFieldHandle As Long, ConditionFieldLength%, condition%, SortDirection%) As Integer

Private Const PE_FIELD_NAME_LEN = 512

Private Const PE_GO_TBN_ALL_GROUPS_UNSORTED = 0
Private Const PE_GO_TBN_ALL_GROUPS_SORTED = 1
Private Const PE_GO_TBN_TOP_N_GROUPS = 2
Private Const PE_GO_TBN_BOTTOM_N_GROUPS = 3

Private Type PEGroupOptions
    StructSize As Integer
    'when setting, pass a PE_GC_ constant, or PE_UNCHANGED for no change.
    'when getting, use PE_GC_TYPEMASK and PE_GC_CONDITIONMASK to decode the condition.
    condition As Integer
    fieldName As String * PE_FIELD_NAME_LEN ' formula form, or empty for no change.
    SortDirection As Integer                ' a PE_SF_ const, or PE_UNCHANGED for no change.
    repeatGroupHeader As Integer            ' BOOL value, or PE_UNCHANGED for no change.
    keepGroupTogether As Integer            ' BOOL value, or PE_UNCHANGED for no change.
    topOrBottomNGroups As Integer           ' a PE_GO_TBN_ constant, or PE_UNCHANGED for no change.
    topOrBottomNSortFieldName As String * PE_FIELD_NAME_LEN ' formula form, or empty for no change.
    ntoporbottomgroups As Integer           ' the number of groups to keep, 0 for all, or PE_UNCHANGED for no change.
    discardOtherGroups As Integer           ' BOOL value, or PE_UNCHANGED for no change.
    ignored As Integer                     ' for 4 byte alignment ignored.
    hierarchicalSorting As Integer              ' Boolean or PE_UNCHANGED
    instanceIDField As String * PE_FIELD_NAME_LEN       ' for hierarchical grouping
    parentIDField As String * PE_FIELD_NAME_LEN         ' for hierarchical grouping
    groupIndent As Long                         ' twips
End Type

Private Const PE_SIZEOF_GROUP_OPTIONS = 10 * PE_WORD_LEN + _
                                       4 * PE_FIELD_NAME_LEN + _
                                       1 * PE_LONG_LEN

Private Declare Function PEGetGroupOptions Lib "crpe32.dll" (ByVal printJob%, ByVal groupN%, groupOptions As PEGroupOptions) As Integer
                                
Private Declare Function PESetGroupOptions Lib "crpe32.dll" (ByVal printJob%, ByVal groupN%, groupOptions As PEGroupOptions) As Integer

' Controlling formulas, selection formulas and group selection formulas
' ---------------------------------------------------------------------

Private Declare Function PEGetNFormulas Lib "crpe32.dll" (ByVal printJob%) As Integer

Private Declare Function PEGetNthFormula Lib "crpe32.dll" (ByVal printJob%, ByVal FormulaN%, nameHandle As Long, nameLength%, TextHandle As Long, TextLength%) As Integer

Private Declare Function PEGetFormula Lib "crpe32.dll" (ByVal printJob%, ByVal formulaName$, TextHandle As Long, TextLength%) As Integer

Private Declare Function PESetFormula Lib "crpe32.dll" (ByVal printJob%, ByVal formulaName$, ByVal formulaString$) As Integer

Private Declare Function PECheckFormula Lib "crpe32.dll" (ByVal printJob%, ByVal formulaName$) As Integer

Private Declare Function PEGetSelectionFormula Lib "crpe32.dll" (ByVal printJob%, TextHandle As Long, TextLength%) As Integer

Private Declare Function PESetSelectionFormula Lib "crpe32.dll" (ByVal printJob%, ByVal formulaString$) As Integer

Private Declare Function PECheckSelectionFormula Lib "crpe32.dll" (ByVal printJob%) As Integer

Private Declare Function PEGetGroupSelectionFormula Lib "crpe32.dll" (ByVal printJob%, TextHandle As Long, TextLength%) As Integer

Private Declare Function PESetGroupSelectionFormula Lib "crpe32.dll" (ByVal printJob%, ByVal formulaString$) As Integer

Declare Function PECheckGroupSelectionFormula Lib "crpe32.dll" (ByVal printJob%) As Integer


' SQL Expressions
'-----------------

Private Declare Function PEGetNSQLExpressions Lib "crpe32.dll" (ByVal printJob%) As Integer

Private Declare Function PEGetNthSQLExpression Lib "crpe32.dll" (ByVal printJob%, ByVal expressionN%, nameHandle&, nameLength%, TextHandle&, TextLength%) As Integer

Private Declare Function PEGetSQLExpression Lib "crpe32.dll" (ByVal printJob%, ByVal expressionName$, TextHandle&, TextLength%) As Integer

Private Declare Function PESetSQLExpression Lib "crpe32.dll" (ByVal printJob%, ByVal expressionName$, ByVal expressionString$) As Integer

Private Declare Function PECheckSQLExpression Lib "crpe32.dll" (ByVal printJob%, ByVal expressionName$) As Integer

'********************************************************************************
' NOTE : Stored Procedures
'
' The previous Stored Procedure API Calls PEGetNParams, PEGetNthParam,
' PEGetNthParamInfo and PESetNthParam have been made obsolete.  Older
' applications that used these API Calls will still work as before, but for new
' development please use the new Parameter API calls below,
'
' The Stored Procedure Parameters have now been unified with the Parameter
' Fields.
'
' The replacements for these calls are as follows :
'      PEGetNParams        = PEGetNParameterFields
'      PEGetNthParam       = PEGetNthParameterField
'      PEGetNthParamInfo   = PEGetParameterValueInfo
'      PESetNthParam       = PESetNthParameterField
'
' NOTE : To tell if a Parameter Field is a Stored Procedure, use the
'        PEGetNthParameterType or PEGetNthParameterField API Calls
'
' If you wish to SET a parameter to NULL then set the CurrentValue to CRWNULL.
' The CRWNULL is of Type String and is independant of the datatype of the
' parameter.
'
'********************************************************************************


' Controlling Parameter Fields
' ----------------------------

Private Const PE_PF_REPORT_NAME_LEN = 128
Private Const PE_PF_NAME_LEN = 256
Private Const PE_PF_PROMPT_LEN = 256
Private Const PE_PF_VALUE_LEN = 256
Private Const PE_PF_EDITMASK_LEN = 256

Private Const PE_PF_NUMBER = 0
Private Const PE_PF_CURRENCY = 1
Private Const PE_PF_BOOLEAN = 2
Private Const PE_PF_DATE = 3
Private Const PE_PF_STRING = 4
Private Const PE_PF_DATETIME = 5
Private Const PE_PF_TIME = 6
Private Type PEParameterFieldInfo
    'Initialize to PE_SIZEOF_PARAMETER_FIELD_INFO.
    StructSize As Integer

    'PE_PF_ constant
    valueType As Integer

    'Indicate the default value is set in PEParameterFieldInfo.
    DefaultValueSet As Integer

    'Indicate the current value is set in PEParameterFieldInfo.
    CurrentValueSet As Integer

    'All strings are null-terminated.
    Name As String * PE_PF_NAME_LEN
    Prompt As String * PE_PF_PROMPT_LEN

    ' Could be Number, Date, DateTime, Time, Boolean, or String
    DefaultValue As String * PE_PF_VALUE_LEN
    currentValue As String * PE_PF_VALUE_LEN

    'name of report where the field belongs, only used in PEGetNthParameterField
    ReportName As String * PE_PF_REPORT_NAME_LEN

    'returns false (0) if parameter is linked, not in use, or has current value set
    needsCurrentValue As Integer
    
    'for String values this will be TRUE if the string is limited on length, for
    'other types it will be TRUE if the parameter is limited by a range
    isLimited As Integer

    ' For string fields, these are the minimum/maximum length of the string.
    ' For numeric fields, they are the minimum/maximum numeric value.
    ' For other fields, use PEGetParameterMinMaxValue
    MinSize As Double
    MaxSize As Double

    'An edit mask that restricts what may be entered for string parameters.
    EditMask As String * PE_PF_EDITMASK_LEN

    'return true if it is essbase sub var
    isHidden As Integer
    
End Type
Private Const PE_SIZEOF_VARINFO_TYPE = 5 * PE_WORD_LEN + PE_PF_NAME_LEN + PE_PF_PROMPT_LEN + 2 * PE_PF_VALUE_LEN + PE_PF_REPORT_NAME_LEN
Private Const PE_SIZEOF_PARAMETER_FIELD_INFO = 7 * PE_WORD_LEN + PE_PF_NAME_LEN + PE_PF_PROMPT_LEN + 2 * PE_PF_VALUE_LEN + PE_PF_REPORT_NAME_LEN + PE_PF_EDITMASK_LEN + 2 * PE_DOUBLE_LEN

Private Declare Function PEGetNParameterFields Lib "crpe32.dll" (ByVal printJob%) As Integer

Private Declare Function PEGetNthParameterField Lib "crpe32.dll" (ByVal printJob%, ByVal varN%, varInfo As PEParameterFieldInfo) As Integer

Private Declare Function PESetNthParameterField Lib "crpe32.dll" (ByVal printJob%, ByVal varN%, varInfo As PEParameterFieldInfo) As Integer

'*** Converting parameterInfo default value or current value into value info ****
Private Const PE_VI_STRING_LEN = 256

' define value type
Private Const PE_VI_NUMBER = 0
Private Const PE_VI_CURRENCY = 1
Private Const PE_VI_BOOLEAN = 2
Private Const PE_VI_DATE = 3
Private Const PE_VI_STRING = 4
Private Const PE_VI_DATETIME = 5
Private Const PE_VI_TIME = 6
Private Const PE_VI_INTEGER = 7
Private Const PE_VI_COLOR = 8
Private Const PE_VI_CHAR = 9
Private Const PE_VI_LONG = 10
Private Const PE_VI_NOVALUE = 100

Private Type PEValueInfo
    StructSize As Integer
    valueType As Integer  'a PE_VI_ constant
    viNumber As Double
    viCurrency As Double
    viBoolean As Long
    viString As String * PE_VI_STRING_LEN
    viDate(0 To 2) As Integer ' year, month, day
    viDateTime(0 To 5) As Integer ' year, month, day, hour, minute, second
    viTime(0 To 2) As Integer  ' hour, minute, second
    viColor As Long
    viInteger As Integer
    viC As Byte
    ignored As Byte 'for 4 byte alignment. ignored.
    viLong As Long
End Type

Private Const PE_SIZEOF_VALUE_INFO = 2 * PE_BYTE_LEN + _
                                   15 * PE_WORD_LEN + _
                                    3 * PE_LONG_LEN + _
                                    2 * PE_DOUBLE_LEN + _
                                    1 * PE_VI_STRING_LEN
                                     
Private Declare Function PEConvertPFInfoToVInfo Lib "crpe32.dll" (ByVal Value As Any, ByVal valueType%, valueInfo As PEValueInfo) As Integer
Private Declare Function PEConvertVInfoToPFInfo Lib "crpe32.dll" (valueInfo As PEValueInfo, valueType%, ByVal Value As Any) As Integer

' Default values for Parameter fields.
' - If return value is -1 then an error has occurred.
' ------------------------------------
Private Declare Function PEGetNParameterDefaultValues Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$) As Integer

Private Declare Function PEGetNthParameterDefaultValue Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, ByVal Index%, valueInfo As PEValueInfo) As Integer

Private Declare Function PESetNthParameterDefaultValue Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, ByVal Index%, valueInfo As PEValueInfo) As Integer

Private Declare Function PEAddParameterDefaultValue Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, valueInfo As PEValueInfo) As Integer

Private Declare Function PEDeleteNthParameterDefaultValue Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, ByVal Index%) As Integer

' Min/Max values for Parameter fields.
' ------------------------------------
Private Declare Function PEGetParameterMinMaxValue Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, valueMin As PEValueInfo, valueMax As PEValueInfo) As Integer

Private Declare Function PESetParameterMinMaxValue Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, valueMin As PEValueInfo, valueMax As PEValueInfo) As Integer

' Pick list options in Parameter fields.
Private Declare Function PEGetNthParameterValueDescription Lib "crpe32.dll" (ByVal printJob As Integer, ByVal parameterFieldName As String, ByVal ReportName As String, ByVal Index As Integer, valueDesc As Long, valueDescLength As Integer) As Integer
Private Declare Function PESetNthParameterValueDescription Lib "crpe32.dll" (ByVal printJob As Integer, ByVal parameterFieldName As String, ByVal ReportName As String, ByVal Index As Integer, ByVal valueDesc As String) As Integer

' constants for sortMethod in PEParameterPickListOption struct
Private Const PE_OR_NO_SORT = 0
Private Const PE_OR_ALPHANUMERIC_ASCENDING = 1
Private Const PE_OR_ALPHANUMERIC_DESCENDING = 2
Private Const PE_OR_NUMERIC_ASCENDING = 3
Private Const PE_OR_NUMERIC_DESCENDING = 4

Private Type PEParameterPickListOption
    StructSize As Integer       ' initialize to PE_SIZEOF_PICK_LIST_OPTION
    showDescOnly As Integer     ' boolean value or PE_UNCHANGED
    sortMethod As Integer       ' enum type const, PE_UNCHANGED for no change
    sortBasedOnDesc As Integer  ' boolean value or PE_UNCHANGED
End Type

Private Const PE_SIZEOF_PICK_LIST_OPTION = (4 * PE_WORD_LEN)

Private Declare Function PEGetParameterPickListOption Lib "crpe32.dll" (ByVal printJob As Integer, ByVal parameterFieldName As String, ByVal ReportName As String, pickListOption As PEParameterPickListOption) As Integer
Private Declare Function PESetParameterPickListOption Lib "crpe32.dll" (ByVal printJob As Integer, ByVal parameterFieldName As String, ByVal ReportName As String, pickListOption As PEParameterPickListOption) As Integer

' Parameter current values
' ------------------------

'parameter field origin
Private Const PE_PO_REPORT = 0
Private Const PE_PO_STOREDPROC = 1
Private Const PE_PO_QUERY = 2

' range info
Private Const PE_RI_INCLUDEUPPERBOUND = 1
Private Const PE_RI_INCLUDELOWERBOUND = 2
Private Const PE_RI_NOUPPERBOUND = 4
Private Const PE_RI_NOLOWERBOUND = 8

Private Const PE_DR_HASRANGE = 0
Private Const PE_DR_HASDISCRETE = 1
Private Const PE_DR_HASDISCRETEANDRANGE = 2

Private Type PEParameterValueInfo
    StructSize As Integer
    isNullable As Integer               ' Boolean value or PE_UNCHANGED for no change.
    disallowEditing As Integer          ' Boolean value or PE_UNCHANGED for no change.
    allowMultipleValues As Integer      ' Boolean value or PE_UNCHANGED for no change.
    hasDiscreteValues As Integer        ' PE_UNCHANGED for no change.
                                        ' 0 means has ranges, 1 means has discrete values
                                        ' 2 means has discrete and ranged values
    partOfGroup As Integer              ' Boolean value or PE_UNCHANGED for no change.
    groupNum As Integer                 ' a group number or PE_UNCHANGED for no change.
    mutuallyExclusiveGroup As Integer   ' Boolean value or PE_UNCHANGED for no change.
End Type

Private Const PE_SIZEOF_PARAMETER_VALUE_INFO = 8 * PE_WORD_LEN

Private Declare Function PEGetParameterValueInfo Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, valueInfo As PEParameterValueInfo) As Integer

Private Declare Function PESetParameterValueInfo Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, valueInfo As PEParameterValueInfo) As Integer

' If return value is -1 then an error has occurred.
Private Declare Function PEGetNParameterCurrentValues Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$) As Integer

Private Declare Function PEGetNthParameterCurrentValue Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, ByVal Index%, currentValue As PEValueInfo) As Integer

Private Declare Function PEAddParameterCurrentValue Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, currentValue As PEValueInfo) As Integer

' If return value is -1 then an error has occurred.
Private Declare Function PEGetNParameterCurrentRanges Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$) As Integer

Private Declare Function PEGetNthParameterCurrentRange Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, ByVal Index%, rangeStart As PEValueInfo, rangeEnd As PEValueInfo, ByVal rangeInfo%) As Integer

Private Declare Function PEAddParameterCurrentRange Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$, rangeStart As PEValueInfo, rangeEnd As PEValueInfo, ByVal rangeInfo%) As Integer

Private Declare Function PEGetNthParameterType Lib "crpe32.dll" (ByVal printJob%, ByVal Index%) As Integer 'returns PE_PO_* or -1 if index is invalid.

Private Declare Function PEClearParameterCurrentValuesAndRanges Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal ReportName$) As Integer

' Subreport Functions
' -------------------------------------------

Private Const PE_SUBREPORT_NAME_LEN = 128

' PE_SRI_ONOPENJOB: Reimport the subreport when opening the main report.
' PE_SRI_ONFUNCTIONCALL: Reimport the subreport when the api is called.
Private Const PE_SRI_UNDEFINED = -1
Private Const PE_SRI_ONOPENJOB = 0
Private Const PE_SRI_ONFUNCTIONCALL = 1

Private Type PESubreportInfo
    StructSize As Integer            ' Initialize to PE_SIZEOF_SUBREPORT_INFO.
    
    'Strings are null-terminated.
    Name As String * PE_SUBREPORT_NAME_LEN

    'number of links
    NLinks As Integer

    ' subreport placement.
    isOnDemand As Integer       ' TRUE if the subreport is on demand subreport.
    external As Integer         ' 1: the subreport is imported; 0: otherwise.
    reimportOption As Integer   ' PE_SRI_ONOPENJOB or PE_SRI_ONFUNCTIONCALL
End Type

Private Const PE_SIZEOF_SUBREPORT_INFO = 4 * PE_WORD_LEN + PE_SUBREPORT_NAME_LEN + 1

Private Declare Function PEGetSubreportInfo Lib "crpe32.dll" (ByVal printJob%, ByVal subreportHandle As Long, subreportInfo As PESubreportInfo) As Integer

Private Declare Function PEReimportSubreport Lib "crpe32.dll" (ByVal printJob As Integer, ByVal subreportHandle As Long, linkChanged As Long, reimported As Long) As Integer

' End Subreports


' Controlling sort order and group sort order
' -------------------------------------------

Private Const PE_SF_MAXNAMELEN = 50   ' maximum length of a sort field name

Private Const PE_SF_DESC = 0          ' values for the Direction parameter
Private Const PE_SF_ASC = 1

Private Declare Function PEGetNSortFields Lib "crpe32.dll" (ByVal printJob%) As Integer

Private Declare Function PEGetNthSortField Lib "crpe32.dll" (ByVal printJob%, ByVal SortNumber%, nameHandle As Long, nameLength%, Direction%) As Integer

Private Declare Function PESetNthSortField Lib "crpe32.dll" (ByVal printJob%, ByVal SortNumber%, ByVal SortFieldName$, ByVal Direction%) As Integer

Private Declare Function PEDeleteNthSortField Lib "crpe32.dll" (ByVal printJob%, ByVal SortFieldN%) As Integer

Private Declare Function PEGetNGroupSortFields Lib "crpe32.dll" (ByVal printJob%) As Integer

Private Declare Function PEGetNthGroupSortField Lib "crpe32.dll" (ByVal printJob%, ByVal SortFieldN%, nameHandle As Long, nameLength%, Direction%) As Integer

Private Declare Function PESetNthGroupSortField Lib "crpe32.dll" (ByVal printJob%, ByVal SortFieldN%, ByVal SortGroupName$, ByVal Direction%) As Integer

Private Declare Function PEDeleteNthGroupSortField Lib "crpe32.dll" (ByVal printJob%, ByVal SortFieldN%) As Integer


' Controlling databases
' ---------------------
'
' The following functions allow retrieving and updating database info
' in an opened report, so that a report can be printed using different
' session, server, database, user and/or table location settings.  Any
' changes made to the report via these functions are not permanent, and
' only last as long as the report is open.
'
' The following database functions (except for PELogOnServer and
' PELogOffServer) must be called after PEOpenPrintJob and before
' PEStartPrintJob.

' The function PEGetNTables is called to fetch the number of tables in
' the report.  This includes all PC databases (e.g. Paradox, xBase)
' as well as SQL databases (e.g. SQL Server, Oracle, Netware).

Private Declare Function PEGetNTables Lib "crpe32.dll" (ByVal printJob%) As Integer

' The function PEGetNthTableType allows the application to determine the
' type of each table.  The application can test DBType (equal to
' PE_DT_STANDARD or PE_DT_SQL), or test the database DLL name used to
' create the report.  DLL names have the following naming convention:
'     - PDB*.DLL for standard (non-SQL) databases,
'     - PDS*.DLL for SQL databases.
'
' In the case of ODBC (PDSODBC.DLL) the DescriptiveName includes the
' ODBC data source name.

Private Const PE_DLL_NAME_LEN = 64
Private Const PE_FULL_NAME_LEN = 256
Private Const PE_SIZEOF_TABLE_TYPE = 324  ' # bytes in PETableType

Private Const PE_DT_STANDARD = 1   ' values for DBType
Private Const PE_DT_SQL = 2
Private Const PE_DT_SQL_STORED_PROCEDURE = 3

Private Type PETableType
    StructSize As Integer   ' initialize to # bytes in PETableType

    DLLName As String * PE_DLL_NAME_LEN
    DescriptiveName  As String * PE_FULL_NAME_LEN

    DBType As Integer
End Type

Private Declare Function PEGetNthTableType Lib "crpe32.dll" (ByVal printJob%, ByVal TableN%, TableType As PETableType) As Integer

' The functions PEGetNthTableSessionInfo and PESetNthTableSessionInfo
' are only used when connecting to MS Access databases (which require a
' session to be opened first)

Private Const PE_SESS_USERID_LEN = 128
Private Const PE_SESS_PASSWORD_LEN = 128
Private Const PE_SIZEOF_SESSION_INFO = 262   ' # bytes in PESessionInfo

Private Type PESessionInfo
    'initialize to # bytes in PESessionInfo
    StructSize As Integer

    ' Password is undefined when getting information from report.
    UserID As String * PE_SESS_USERID_LEN
    Password As String * PE_SESS_PASSWORD_LEN

    ' SessionHandle is undefined when getting information from report.
    ' When setting information, if it is = 0 the UserID and Password
    ' settings are used, otherwise the SessionHandle is used.
    SessionHandle As Long
End Type

Private Declare Function PEGetNthTableSessionInfo Lib "crpe32.dll" (ByVal printJob%, ByVal TableN%, SessionInfo As PESessionInfo) As Integer

Private Declare Function PESetNthTableSessionInfo Lib "crpe32.dll" (ByVal printJob%, ByVal TableN%, SessionInfo As PESessionInfo, ByVal PropagateAcrossTables%) As Integer

' Logging on is performed when printing the report, but the correct
' log on information must first be set using PESetNthTableLogOnInfo.
' Only the password is required, but the server, database, and
' user names may optionally be overriden as well.
'
' If the parameter propagateAcrossTables is TRUE, the new log on info
' is also applied to any other tables in this report that had the
' same original server and database names as this table.  If FALSE
' only this table is updated.
'
' Logging off is performed automatically when the print job is closed.

Private Const PE_SERVERNAME_LEN = 128
Private Const PE_DATABASENAME_LEN = 128
Private Const PE_USERID_LEN = 128
Private Const PE_PASSWORD_LEN = 128
Private Const PE_SIZEOF_LOGON_INFO = 514   ' # bytes in PELogOnInfo

Private Type PELogOnInfo
    ' initialize to # bytes in PELogOnInfo
    StructSize As Integer

    ' For any of the following values an empty string ("") means to use
    ' the value already set in the report.  To override a value in the
    ' report use a non-empty string (e.g. "Server A").
    '
    ' For Netware SQL, pass the dictionary path name in ServerName and
    ' data path name in DatabaseName.

    ServerName As String * PE_SERVERNAME_LEN
    DatabaseName  As String * PE_DATABASENAME_LEN
    UserID As String * PE_USERID_LEN

    ' Password is undefined when getting information from report.

    Password  As String * PE_PASSWORD_LEN
End Type

Private Declare Function PEGetNthTableLogOnInfo Lib "crpe32.dll" (ByVal printJob%, ByVal TableN%, LogOnInfo As PELogOnInfo) As Integer
Private Declare Function PESetNthTableLogOnInfo Lib "crpe32.dll" (ByVal printJob%, ByVal TableN%, LogOnInfo As PELogOnInfo, ByVal Propagate%) As Integer

' A table's location is fetched and set using PEGetNthTableLocation and
' PESetNthTableLocation.  This name is database-dependent, and must be
' formatted correctly for the expected database.  For example:
'     - Paradox: "c:\crw\ORDERS.DB"
'     - SQL Server: "publications.dbo.authors"

Private Const PE_TABLE_LOCATION_LEN = 256
Private Const PE_CONNECTION_BUFFER_LEN = 512

Private Type PETableLocation
    ' initialize to # bytes in PETableLocation
    StructSize As Integer
    Location  As String * PE_TABLE_LOCATION_LEN
    SubLocation As String * PE_TABLE_LOCATION_LEN
    ConnectBuffer As String * PE_CONNECTION_BUFFER_LEN  ' Connection Info for attached tables
End Type

Private Const PE_SIZEOF_TABLE_LOCATION = 1026   ' # bytes in PETableLocation

Private Declare Function PEGetNthTableLocation Lib "crpe32.dll" (ByVal printJob%, ByVal TableN%, Location As PETableLocation) As Integer
Private Declare Function PESetNthTableLocation Lib "crpe32.dll" (ByVal printJob%, ByVal TableN%, Location As PETableLocation) As Integer

' The function PETestNthTableConnectivity tests whether a database
' table's settings are valid and ready to be reported on.  It returns
' true if the database session, log on, and location info is all
' correct.
'
' This is useful, for example, in prompting the user and testing a
' server password before printing begins.
'
' This function may require a significant amount of time to complete,
' since it will first open a user session (if required), then log onto
' the database server (if required), and then open the appropriate
' database table (to test that it exists).  It does not read any data,
' and closes the table immediately once successful.  Logging off is
' performed when the print job is closed.
'
' If it fails in any of these steps, the error code set indicates
' which database info needs to be updated using functions above:
'    - If it is unable to begin a session, PE_ERR_DATABASESESSION is set,
'      and the application should update with PESetNthTableSessionInfo.
'    - If it is unable to log onto a server, PE_ERR_DATABASELOGON is set,
'      and the application should update with PESetNthTableLogOnInfo.
'    - If it is unable open the table, PE_ERR_DATABASELOCATION is set,
'      and the application should update with PESetNthTableLocation.

Private Declare Function PETestNthTableConnectivity Lib "crpe32.dll" (ByVal printJob%, ByVal TableN%) As Integer

' PELogOnServer and PELogOffServer can be called at any time to log on
' and off of a database server.  These functions are not required if
' function PESetNthTableLogOnInfo above was already used to set the
' password for a table.
'
' These functions require a database DLL name, which can be retrieved
' using PEGetNthTableType above.
'
' This function can also be used for non-SQL tables, such as password-
' protected Paradox tables.  Call this function to set the password
' for the Paradox DLL before beginning printing.
'
' Note: When printing using PEStartPrintJob the ServerName passed in
' PELogOnServer must agree exactly with the server name stored in the
' report.  If this is not true use PESetNthTableLogOnInfo to perform
' logging on instead.

Private Declare Function PELogOnServer Lib "crpe32.dll" (ByVal DLLName$, LogOnInfo As PELogOnInfo) As Integer
Private Declare Function PELogOffServer Lib "crpe32.dll" (ByVal DLLName$, LogOnInfo As PELogOnInfo) As Integer
Private Declare Function PELogOnSQLServerWithPrivateInfo Lib "crpe32.dll" (ByVal DLLName$, ByVal PrivateInfo As Long) As Integer


' Overriding SQL query in report
' ------------------------------
'
' PEGetSQLQuery returns the same query as appears in the Show SQL Query
' dialog in CRW, in syntax specific to the database driver you are using.
'
' PESetSQLQuery is mostly useful for reports with SQL queries that
' were explicitly edited in the Show SQL Query dialog in CRW, i.e. those
' reports that needed database-specific selection criteria or joins.
' (Otherwise it is usually best to continue using function calls such as
' PESetSelectionFormula and let CRW build the SQL query automatically.)
'
' PESetSQLQuery has the same restrictions as editing in the Show SQL
' Query dialog; in particular that changes are accepted in the FROM and
' WHERE clauses but ignored in the SELECT list of fields.

Private Declare Function PEGetSQLQuery Lib "crpe32.dll" (ByVal printJob%, TextHandle As Long, TextLength%) As Integer

Private Declare Function PESetSQLQuery Lib "crpe32.dll" (ByVal printJob%, ByVal QueryString$) As Integer

'Field mapping types
Private Const PE_FM_AUTO_FLD_MAP = 0           'Automatic field name mapping
                                             'unmapped report fields will be removed
Private Const PE_FM_CRPE_PROMPT_FLD_MAP = 1    'CRPE provided dialog box to map field manually

Private Declare Function PESetFieldMappingType Lib "crpe32.dll" (ByVal printJob%, ByVal mappingtype As Integer) As Integer

Private Declare Function PEGetFieldMappingType Lib "crpe32.dll" (ByVal printJob%, mappingtype As Integer) As Integer

Private Declare Function PEVerifyDatabase Lib "crpe32.dll" (ByVal printJob%) As Integer

' constants returned from PECheckNthTableDifferences, can be any
' combination of the following:
Private Const PE_TCD_OKAY = &H0
Private Const PE_TCD_DATABASENOTFOUND = &H1
Private Const PE_TCD_SERVERNOTFOUND = &H2
Private Const PE_TCD_SERVERNOTOPENED = &H4
Private Const PE_TCD_ALIASCHANGED = &H8
Private Const PE_TCD_INDEXESCHANGED = &H10
Private Const PE_TCD_DRIVERCHANGED = &H20
Private Const PE_TCD_DICTIONARYCHANGED = &H40
Private Const PE_TCD_FILETYPECHANGED = &H80
Private Const PE_TCD_RECORDSIZECHANGED = &H100
Private Const PE_TCD_ACCESSCHANGED = &H200
Private Const PE_TCD_PARAMETERSCHANGED = &H400
Private Const PE_TCD_LOCATIONCHANGED = &H800
Private Const PE_TCD_DATABASEOTHER = &H1000
Private Const PE_TCD_NUMFIELDSCHANGED = &H10000
Private Const PE_TCD_FIELDOTHER = &H20000
Private Const PE_TCD_FIELDNAMECHANGED = &H40000
Private Const PE_TCD_FIELDDESCCHANGED = &H80000
Private Const PE_TCD_FIELDTYPECHANGED = &H100000
Private Const PE_TCD_FIELDSIZECHANGED = &H200000
Private Const PE_TCD_NATIVEFIELDTYPECHANGED = &H400000
Private Const PE_TCD_NATIVEFIELDOFFSETCHANGED = &H800000
Private Const PE_TCD_NATIVEFIELDSIZECHANGED = &H1000000
Private Const PE_TCD_FIELDDECPLACESCHANGED = &H2000000

Private Type PETableDifferenceInfo
    StructSize As Integer
    tableDifferences As Long    ' any combination of PE_TC_*
    reserved1 As Long           ' reserved - do not use
    reserved2 As Long           ' reserved - do not use
End Type

Private Const PE_SIZEOF_TABLE_DIFFERENCE_INFO = (1 * PE_WORD_LEN) + (3 * PE_LONG_LEN)

' Not implemented for reports based on dictionary, returns PE_ERR_NOTIMPLEMENTED
Private Declare Function PECheckNthTableDifferences Lib "crpe32.dll" (ByVal printJob As Integer, ByVal TableN As Integer, tabledifferenceinfo As PETableDifferenceInfo) As Integer

' Saved data
' ----------
'
' Use PEHasSavedData to find out if a report currently has saved data
' associated with it.  This may or may not be TRUE when a print job is
' first opened from a report file.  Since data is saved during a print,
' this will always be TRUE immediately after a report is printed.
'
' Use PEDiscardSavedData to release the saved data associated with a
' report.  The next time the report is printed, it will get current data
' from the database.
'
' The default behavior is for a report to use its saved data, rather than
' refresh its data from the database when printing a report.

Private Declare Function PEHasSavedData Lib "crpe32.dll" (ByVal printJob%, HasSavedData As Long) As Integer

Private Declare Function PEDiscardSavedData Lib "crpe32.dll" (ByVal printJob%) As Integer


' Report title
' ------------

Private Declare Function PEGetReportTitle Lib "crpe32.dll" (ByVal printJob%, TitleHandle As Long, titleLength%) As Integer
Private Declare Function PESetReportTitle Lib "crpe32.dll" (ByVal printJob%, ByVal Title$) As Integer


' Controlling print to window
' ---------------------------

Private Declare Function PEOutputToWindow Lib "crpe32.dll" (ByVal printJob%, ByVal Title$, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal height As Long, ByVal style As Long, ByVal PWindow As Long) As Integer

Private Type PEWindowOptions
    StructSize As Integer            'initialize to PE_SIZEOF_WINDOW_OPTIONS

    hasGroupTree As Integer          '0 or 1, except use PE_UNCHANGED for no change
    canDrillDown As Integer          '0 or 1, except use PE_UNCHANGED for no change
    hasNavigationControls As Integer '0 or 1, except use PE_UNCHANGED for no change
    hasCancelButton As Integer       '0 or 1, except use PE_UNCHANGED for no change
    hasPrintButton As Integer        '0 or 1, except use PE_UNCHANGED for no change
    hasExportButton As Integer       '0 or 1, except use PE_UNCHANGED for no change
    hasZoomControl As Integer        '0 or 1, except use PE_UNCHANGED for no change
    hasCloseButton As Integer        '0 or 1, except use PE_UNCHANGED for no change
    hasProgressControls As Integer   '0 or 1, except use PE_UNCHANGED for no change
    hasSearchButton As Integer       '0 or 1, except use PE_UNCHANGED for no change
    hasPrintSetupButton As Integer   '0 or 1, except use PE_UNCHANGED for no change
    hasRefreshButton As Integer      '0 or 1, except use PE_UNCHANGED for no change
    showToolbarTips As Integer       ' BOOL value, except use PE_UNCHANGED for no change
                                     ' default is TRUE (*Show* tooltips on toolbar)
    showDocumentTips As Integer      ' BOOL value, except use PE_UNCHANGED for no change
                                     ' default is FALSE (*Hide* tooltips on document)
    hasLaunchButton As Integer       ' Launch Seagate Analysis button on toolbar.
                                     ' BOOL value, except use PE_UNCHANGED for no change
                                     ' default is FALSE
End Type

Private Const PE_SIZEOF_WINDOW_OPTIONS = (16 * PE_WORD_LEN)

Private Declare Function PEGetWindowOptions Lib "crpe32.dll" (ByVal printJob%, Options As PEWindowOptions) As Integer

Private Declare Function PESetWindowOptions Lib "crpe32.dll" (ByVal printJob%, Options As PEWindowOptions) As Integer

Private Declare Function PEGetWindowHandle Lib "crpe32.dll" (ByVal printJob%) As Long

Private Declare Sub PECloseWindow Lib "crpe32.dll" (ByVal printJob%)


' Controlling printed pages
' -------------------------

Private Declare Function PEShowNextPage Lib "crpe32.dll" (ByVal printJob%) As Integer
Private Declare Function PEShowFirstPage Lib "crpe32.dll" (ByVal printJob%) As Integer
Private Declare Function PEShowPreviousPage Lib "crpe32.dll" (ByVal printJob%) As Integer
Private Declare Function PEShowLastPage Lib "crpe32.dll" (ByVal printJob%) As Integer
Private Declare Function PEGetNPages Lib "crpe32.dll" (ByVal printJob%) As Integer
Private Declare Function PEShowNthPage Lib "crpe32.dll" (ByVal printJob%, ByVal pageN%) As Integer

Private Const PE_ZOOM_FULL_SIZE = 0
Private Const PE_ZOOM_SIZE_FIT_ONE_SIDE = 1
Private Const PE_ZOOM_SIZE_FIT_BOTH_SIDES = 2

Private Declare Function PEZoomPreviewWindow Lib "crpe32.dll" (ByVal printJob%, ByVal ZoomLevel%) As Integer
' ZoomLevel is a percent from 25 to 400 or a PE_ZOOM_ constant

' Controlling print window when print control buttons hidden
' ----------------------------------------------------------

Private Declare Function PEShowPrintControls Lib "crpe32.dll" (ByVal printJob%, ByVal ShowPrintControls%) As Integer

Private Declare Function PEPrintControlsShowing Lib "crpe32.dll" (ByVal printJob%, ControlsShowing As Long) As Integer

Private Declare Function PEPrintWindow Lib "crpe32.dll" (ByVal printJob%, ByVal WaitNoWait%) As Integer

Private Declare Function PEExportPrintWindow Lib "crpe32.dll" (ByVal printJob%, ByVal ToMail%, ByVal WaitUntilDone%) As Integer

Private Declare Function PENextPrintWindowMagnification Lib "crpe32.dll" (ByVal printJob%) As Integer


' Changing printer selection
' --------------------------
Private Const CCHDEVICENAME = 32
Private Const CCHFORMNAME = 32
Private Type POINTAPI
    x As Long
    y As Long
End Type
Private Type DEVMODE_NEW
  dmDeviceName As String * CCHDEVICENAME
  dmSpecVersion As Integer
  dmDriverVersion As Integer
  dmSize As Integer
  dmDriverExtra As Integer
  dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
            dmPosition As POINTAPI
            dmDisplayOrientation As Long
            dmDisplayFixedOutput As Long
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCHFORMNAME
    dmLogPixels As Integer
    dmBitsPerPel As Long
    dmPelsWidth As Long
    dmPelsHeight As Long
        dmDisplayFlags As Long
        dmNup As Long
  dmDisplayFrequency As Long
        dmICMMethod As Long
        dmICMIntent As Long
        dmMediaType As Long
        dmDitherType As Long
        dmReserved1 As Long
        dmReserved2 As Long
    dmPanningWidth As Long
    dmPanningHeight As Long
End Type

'/* field selection bits */
'Private Const DM_ORIENTATION = &H1
'Private Const DM_PAPERSIZE = &H2
'Private Const DM_PAPERLENGTH = &H4
'Private Const DM_PAPERWIDTH = &H8
'Private Const DM_SCALE = &H10
'#if(WINVER >= =&h0500)
Private Const DM_POSITION = &H20
Private Const DM_NUP = &H40
'#endif /* WINVER >= =&h0500 */
'#if(WINVER >= =&h0501)
Private Const DM_DISPLAYORIENTATION = &H80
'#endif /* WINVER >= =&h0501 */
'Private Const DM_COPIES = &H100
'Private Const DM_DEFAULTSOURCE = &H200
'Private Const DM_PRINTQUALITY = &H400
'Private Const DM_COLOR = &H800
'Private Const DM_DUPLEX = &H1000
'Private Const DM_YRESOLUTION = &H2000
'Private Const DM_TTOPTION = &H4000
Private Const DM_COLLATE = &H8000
Private Const DM_FORMNAME = &H10000
Private Const DM_LOGPIXELS = &H20000
Private Const DM_BITSPERPEL = &H40000
Private Const DM_PELSWIDTH = &H80000
Private Const DM_PELSHEIGHT = &H100000
Private Const DM_DISPLAYFLAGS = &H200000
Private Const DM_DISPLAYFREQUENCY = &H400000
'#if(WINVER >= =&h0400)
Private Const DM_ICMMETHOD = &H800000
Private Const DM_ICMINTENT = &H1000000
Private Const DM_MEDIATYPE = &H2000000
Private Const DM_DITHERTYPE = &H4000000
Private Const DM_PANNINGWIDTH = &H8000000
Private Const DM_PANNINGHEIGHT = &H10000000
'#endif /* WINVER >= =&h0400 */
'#if(WINVER >= =&h0501)
Private Const DM_DISPLAYFIXEDOUTPUT = &H20000000
'#endif /* WINVER >= =&h0501 */

Private Declare Sub CopyMemory Lib "kernel32" _
      Alias "RtlMoveMemory" ( _
      Destination As Any, _
      Source As Any, _
      ByVal Length As Long)

Private Declare Function PESelectPrinter Lib "crpe32.dll" (ByVal printJob%, ByVal PrinterDriver$, ByVal PrinterName$, ByVal PortName$, DEVMODE As Any) As Integer

Private Declare Function PEGetSelectedPrinter Lib "crpe32.dll" (ByVal printJob%, DriverHandle As Long, DriverLength%, PrinterHandle As Long, PrinterLength%, PortHandle As Long, PortLength%, DEVMODE As Any) As Integer
Private Declare Function PEGetSelectedPrinter2 Lib "crpe32.dll" Alias "PEGetSelectedPrinter" (ByVal printJob%, DriverHandle As Long, DriverLength%, PrinterHandle As Long, PrinterLength%, PortHandle As Long, PortLength%, DEVMODE As crDEVMODE) As Integer

Private Declare Function PEFreeDevMode Lib "crpe32.dll" (ByVal printJob As Integer, MODE As Any) As Integer



' Controlling print to printer
' ----------------------------

Private Declare Function PEOutputToPrinter Lib "crpe32.dll" (ByVal printJob%, ByVal nCopies%) As Integer
Private Declare Function PEGetJobStatus Lib "crpe32.dll" (ByVal printJob%, JobInfo As PEJobInfo) As Integer

Private Declare Function PESetNDetailCopies Lib "crpe32.dll" (ByVal printJob%, ByVal NDetailCopies%) As Integer

Private Declare Function PEGetNDetailCopies Lib "crpe32.dll" (ByVal printJob%, NDetailCopies%) As Integer

' Extension to PESetPrintOptions function: If the 2nd parameter
' (pointer to PEPrintOptions) is set to 0 (null) the function prompts
' the user for these options.
'
' With this change, you can get the behaviour of the print-to-printer
' button in the print window by calling PESetPrintOptions with a
' null pointer and then calling PEPrintWindow.

Private Const PE_MAXPAGEN = 65535
Private Const PE_FILE_PATH_LEN = 512

Private Const PE_UNCOLLATED = 0
Private Const PE_COLLATED = 1
Private Const PE_DEFAULTCOLLATION = 2

Private Type PEPrintOptions
    StructSize As Integer   ' initialize to # bytes in PEPrintOptions

    ' page and copy numbers are 1-origin
    ' use 0 to preserve the existing settings
    StartPageN As Integer
    stopPageN As Integer

    nReportCopies As Integer
    collation As Integer
    outputFileName As String * PE_FILE_PATH_LEN
End Type

Private Const PE_SIZEOF_PRINT_OPTIONS = 5 * PE_WORD_LEN + PE_FILE_PATH_LEN

Private Declare Function PESetPrintOptions Lib "crpe32.dll" (ByVal printJob%, Options As PEPrintOptions) As Integer

Private Declare Function PEGetPrintOptions Lib "crpe32.dll" (ByVal printJob%, Options As PEPrintOptions) As Integer


' Controlling print to file and export
' ------------------------------------

Private Const PE_FT_RECORD = 0
Private Const PE_FT_TABSEPARATED = 1
Private Const PE_FT_TEXT = 2
Private Const PE_FT_DIF = 3
Private Const PE_FT_CSV = 4
Private Const PE_FT_CHARSEPARATED = 5
Private Const PE_FT_TABFORMATTED = 6

Private Const PE_FIELDDELIMLEN = 17

Private Declare Function PEOutputToFile Lib "crpe32.dll" (ByVal printJob%, ByVal OutputFilePath$, ByVal FileType%, Options As Any) As Integer

Private Type PEExportOptions
    StructSize As Integer   'initialize to # bytes in PEExportOptions

    FormatDLLName As String * PE_DLL_NAME_LEN
    FormatType1 As Integer
    FormatType2 As Integer
    FormatOptions1 As Integer
    FormatOptions2 As Integer

    DestinationDLLName As String * PE_DLL_NAME_LEN
    DestinationType1 As Integer
    DestinationType2 As Integer
    DestinationOptions1 As Integer
    DestinationOptions2 As Integer

    ' following are set by PEGetExportOptions,
    ' and ignored by PEExportTo.
    NFormatOptionsBytes As Integer
    NDestinationOptionsBytes As Integer
End Type

Private Const PE_SIZEOF_EXPORT_OPTIONS = 11 * PE_WORD_LEN + 2 * PE_DLL_NAME_LEN

Private Declare Function PEGetExportOptions Lib "crpe32.dll" (ByVal printJob%, ExportOptions As PEExportOptions) As Integer

Private Declare Function PEExportTo Lib "crpe32.dll" (ByVal printJob%, ExportOptions As PEExportOptions) As Integer


' Setting page margins
' --------------------

Private Const PE_SM_DEFAULT = &H8000

Private Declare Function PESetMargins Lib "crpe32.dll" (ByVal printJob%, ByVal LeftMargin%, ByVal RightMargin%, ByVal TopMargin%, ByVal BottomMargin%) As Integer

Private Declare Function PEGetMargins Lib "crpe32.dll" (ByVal printJob%, LeftMargin%, RightMargin%, TopMargin%, BottomMargin%) As Integer


'Report Summary Info
'-------------------

Private Const PE_SI_APPLICATION_NAME_LEN = 128
Private Const PE_SI_TITLE_LEN = 128
Private Const PE_SI_SUBJECT_LEN = 128
Private Const PE_SI_AUTHOR_LEN = 128
Private Const PE_SI_KEYWORDS_LEN = 128
Private Const PE_SI_COMMENTS_LEN = 512
Private Const PE_SI_REPORT_TEMPLATE_LEN = 128

Private Type PEReportSummaryInfo
    StructSize As Integer
    applicationName As String * PE_SI_APPLICATION_NAME_LEN ' read only.
    Title As String * PE_SI_TITLE_LEN
    subject As String * PE_SI_SUBJECT_LEN
    author As String * PE_SI_AUTHOR_LEN
    keywords As String * PE_SI_KEYWORDS_LEN
    comments As String * PE_SI_COMMENTS_LEN
    reportTemplate As String * PE_SI_REPORT_TEMPLATE_LEN
    savePreviewPicture As Integer   ' BOOL PE_UNCHANGED for no change
End Type

Private Const PE_SIZEOF_REPORT_SUMMARY_INFO = 1 * PE_WORD_LEN + _
                                      PE_SI_APPLICATION_NAME_LEN + _
                                      PE_SI_TITLE_LEN + _
                                      PE_SI_SUBJECT_LEN + _
                                      PE_SI_AUTHOR_LEN + _
                                      PE_SI_KEYWORDS_LEN + _
                                      PE_SI_COMMENTS_LEN + _
                                      PE_SI_REPORT_TEMPLATE_LEN + _
                                      1 * PE_WORD_LEN
                                
Private Declare Function PEGetReportSummaryInfo Lib "crpe32.dll" (ByVal printJob%, summaryInfo As PEReportSummaryInfo) As Integer
Private Declare Function PESetReportSummaryInfo Lib "crpe32.dll" (ByVal printJob%, summaryInfo As PEReportSummaryInfo) As Integer

' Setting section height and format
' ---------------------------------

Private Declare Function PEGetNSections Lib "crpe32.dll" (ByVal printJob%) As Integer
Private Declare Function PEGetNSectionsInArea Lib "crpe32.dll" (ByVal printJob As Integer, ByVal areaCode As Integer) As Integer ' return -1 if failed

Private Declare Function PEGetSectionCode Lib "crpe32.dll" (ByVal printJob%, ByVal sectionN%) As Integer

' MinimumHeight is in twips - 1440 twips to the inch
'This is the replacement API Call for PEGetMinimumSectionHeight which is obsolete.
'The obsolete API will still work for older applications, but use this for all new development
Private Declare Function PEGetSectionHeight Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, height%) As Integer

'This is the replacement API Call for PESetMinimumSectionHeight which is obsolete.
'The obsolete API will still work for older applications, but use this for all new development
Private Declare Function PESetSectionHeight Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, ByVal height%) As Integer

Private Type PESectionOptions
    StructSize As Integer   ' initialize to PE_SIZEOF_SECTION_OPTIONS

    ' use 0 to turn off, 1 to turn on and PE_UNCHANGED to preserve each attribute
    Visible As Integer
    NewPageBefore As Integer
    NewPageAfter As Integer
    KeepTogether As Integer
    SuppressBlankSection As Integer
    ResetPageNAfter As Integer
    PrintAtBottomOfPage As Integer
    backgroundColor As Long   ' Use PE_UNCHANGED_COLOR to preserve the
                              ' existing color.
    underlaySection As Integer
    showArea As Integer
    freeFormPlacement As Integer
    reserveMinimumPageFooter As Integer 'BOOLEAN or PE_UNCHANGED; Sets the size of the Page Footer area                        // to the size of the largest Page Footer section. Used with
                     ' PEGetAreaFormat/PESetAreaFormat; ignored when used with PEGetSectionFormat/PESetSectionFormat.
End Type

Private Const PE_SIZEOF_SECTION_OPTIONS = 12 * PE_WORD_LEN + 1 * 4

'Format formula name
'Old naming convention
Private Const SECTION_VISIBILITY = 58
Private Const NEW_PAGE_BEFORE = 60
Private Const NEW_PAGE_AFTER = 61
Private Const KEEP_SECTION_TOGETHER = 62
Private Const SUPPRESS_BLANK_SECTION = 63
Private Const RESET_PAGE_N_AFTER = 64
Private Const PRINT_AT_BOTTOM_OF_PAGE = 65
Private Const UNDERLAY_SECTION = 66
Private Const SECTION_BACK_COLOUR = 67

'New naming convention
Private Const PE_FFN_AREASECTION_VISIBILITY = 58
Private Const PE_FFN_SECTION_VISIBILITY = 58
Private Const PE_FFN_SHOW_AREA = 59
Private Const PE_FFN_NEW_PAGE_BEFORE = 60
Private Const PE_FFN_NEW_PAGE_AFTER = 61
Private Const PE_FFN_KEEP_SECTION_TOGETHER = 62
Private Const PE_FFN_KEEP_TOGETHER = 62
Private Const PE_FFN_SUPPRESS_BLANK_SECTION = 63
Private Const PE_FFN_RESET_PAGE_N_AFTER = 64
Private Const PE_FFN_PRINT_AT_BOTTOM_OF_PAGE = 65
Private Const PE_FFN_UNDERLAY_SECTION = 66
Private Const PE_FFN_SECTION_BACK_COLOUR = 67
Private Const PE_FFN_SECTION_BACK_COLOR = 67

Private Declare Function PEGetSectionFormatFormula Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, ByVal formulaName%, TextHandle As Long, TextLength%) As Integer

Private Declare Function PESetSectionFormatFormula Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, ByVal formulaName%, ByVal formulaString$) As Integer

Private Declare Function PEGetSectionFormat Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, Options As PESectionOptions) As Integer

Private Declare Function PESetSectionFormat Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, Options As PESectionOptions) As Integer

' Setting area format
' -------------------
                                                                                                               
Private Declare Function PEGetAreaFormatFormula Lib "crpe32.dll" (ByVal printJob%, ByVal areaCode%, ByVal formulaName%, TextHandle As Long, TextLength%) As Integer

Private Declare Function PESetAreaFormatFormula Lib "crpe32.dll" (ByVal printJob%, ByVal areaCode%, ByVal formulaName%, ByVal formulaString$) As Integer

Private Declare Function PEGetAreaFormat Lib "crpe32.dll" (ByVal printJob%, ByVal areaCode%, Options As PESectionOptions) As Integer

Private Declare Function PESetAreaFormat Lib "crpe32.dll" (ByVal printJob%, ByVal areaCode%, Options As PESectionOptions) As Integer


' Setting font info
' -----------------

' values for ScopeCode - may be ORed together
Private Const PE_FIELDS = 1
Private Const PE_TEXT = 2

Private Const PE_UNCHANGED = -1

' to preserve the existing setting, use the following
'   for FontFamily%    use  FF_DONTCARE
'   for FontPitch%     use  DEFAULT_PITCH
'   for CharSet%       use  DEFAULT_CHARSET
'   for PointSize%     use  0
'   for isItalic%      use  PE_UNCHANGED
'   for isUnderlined%  use  PE_UNCHANGED
'   for isStruckOut%   use  PE_UNCHANGED
'   for Weight%        use  0
Private Declare Function PESetFont Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, ByVal scopecode%, ByVal faceName$, ByVal fontFamily%, ByVal fontPitch%, ByVal charSet%, ByVal pointSize%, ByVal isItalic%, ByVal isUnderlined%, ByVal isStruckOut%, ByVal weight%) As Integer

' Subreports
' ----------
Private Declare Function PEGetNSubreportsInSection Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%) As Integer

Private Declare Function PEGetNthSubreportInSection Lib "crpe32.dll" (ByVal printJob%, ByVal sectionCode%, ByVal subreportN%) As Long


'
' G R A P H I N G
'
' - graph type

Private Const PE_GT_BARCHART = 0
Private Const PE_GT_LINECHART = 1
Private Const PE_GT_AREACHART = 2
Private Const PE_GT_PIECHART = 3
Private Const PE_GT_DOUGHNUTCHART = 4
Private Const PE_GT_THREEDRISERCHART = 5
Private Const PE_GT_THREEDSURFACECHART = 6
Private Const PE_GT_SCATTERCHART = 7
Private Const PE_GT_RADARCHART = 8
Private Const PE_GT_BUBBLECHART = 9
Private Const PE_GT_STOCKCHART = 10
Private Const PE_GT_USERDEFINEDCHART = 50         ' for PEGetGraphTypeInfo only -
Private Const PE_GT_UNKNOWNTYPECHART = 100        ' do not use in PESetGraphTypeInfo.

' graph subtype
' - bar charts
Private Const PE_GST_SIDEBYSIDEBARCHART = 0
Private Const PE_GST_STACKEDBARCHART = 1
Private Const PE_GST_PERCENTBARCHART = 2
Private Const PE_GST_FAKED3DSIDEBYSIDEBARCHART = 3
Private Const PE_GST_FAKED3DSTACKEDBARCHART = 4
Private Const PE_GST_FAKED3DPERCENTBARCHART = 5
                                                    
' - line charts
Private Const PE_GST_REGULARLINECHART = 10
Private Const PE_GST_STACKEDLINECHART = 11
Private Const PE_GST_PERCENTAGELINECHART = 12
Private Const PE_GST_LINECHARTWITHMARKERS = 13
Private Const PE_GST_STACKEDLINECHARTWITHMARKERS = 14
Private Const PE_GST_PERCENTAGELINECHARTWITHMARKERS = 15
                                                    
' - charts
Private Const PE_GST_ABSOLUTEAREACHART = 20
Private Const PE_GST_STACKEDAREACHART = 21
Private Const PE_GST_PERCENTAREACHART = 22
Private Const PE_GST_FAKED3DABSOLUTEAREACHART = 23
Private Const PE_GST_FAKED3DSTACKEDAREACHART = 24
Private Const PE_GST_FAKED3DPERCENTAREACHART = 25
                                                    
' - pie charts
Private Const PE_GST_REGULARPIECHART = 30
Private Const PE_GST_FAKED3DREGULARPIECHART = 31
Private Const PE_GST_MULTIPLEPIECHART = 32
Private Const PE_GST_MULTIPLEPROPORTIONALPIECHART = 33
                                                    
' - mmm, doughnut charts
Private Const PE_GST_REGULARDOUGHNUTCHART = 40
Private Const PE_GST_MULTIPLEDOUGHNUTCHART = 41
Private Const PE_GST_MULTIPLEPROPORTIONALDOUGHNUTCHART = 42

' 3D riser charts
Private Const PE_GST_THREEDREGULARCHART = 50
Private Const PE_GST_THREEDPYRAMIDCHART = 51
Private Const PE_GST_THREEDOCTAGONCHART = 52
Private Const PE_GST_THREEDCUTCORNERSCHART = 53
                                                        
' 3D surface charts
Private Const PE_GST_THREEDSURFACEREGULARCHART = 60
Private Const PE_GST_THREEDSURFACEWITHSIDESCHART = 61
Private Const PE_GST_THREEDSURFACEHONEYCOMBCHART = 62
                                                    
' scatter charts
Private Const PE_GST_XYSCATTERCHART = 70
Private Const PE_GST_XYSCATTERDUALAXISCHART = 71
Private Const PE_GST_XYSCATTERWITHLABELSCHART = 72
Private Const PE_GST_XYSCATTERDUALAXISWITHLABELSCHART = 73
                                                    
' radar charts
Private Const PE_GST_REGULARRADARCHART = 80
Private Const PE_GST_STACKEDRADARCHART = 81
Private Const PE_GST_RADARDUALAXISCHART = 82
                                                    
' bubble charts
Private Const PE_GST_REGULARBUBBLECHART = 90
Private Const PE_GST_DUALAXISBUBBLECHART = 91
                                                    
' stocked charts
Private Const PE_GST_HIGHLOWCHART = 100
Private Const PE_GST_HIGHLOWDUALAXISCHART = 101
Private Const PE_GST_HIGHLOWOPENCHART = 102
Private Const PE_GST_HIGHLOWOPENDUALAXISCHART = 103
Private Const PE_GST_HIGHLOWOPENCLOSECHART = 104
Private Const PE_GST_HIGHLOWOPENCLOSEDUALAXISCHART = 105

Private Const PE_GST_UNKNOWNSUBTYPECHART = 1000

Private Type PEGraphTypeInfo
    StructSize As Integer
    GraphType As Integer        ' PE_GT_*, PE_UNCHANGED for no change
    graphSubtype As Integer     ' PE_GST_*, PE_UNCHANGED for no change
End Type

Private Const PE_SIZEOF_GRAPH_TYPE_INFO = (3 * PE_WORD_LEN)

Private Declare Function PEGetGraphTypeInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, graphTypeInfo As PEGraphTypeInfo) As Integer
Private Declare Function PESetGraphTypeInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, graphTypeInfo As PEGraphTypeInfo) As Integer

' graph text

Private Const PE_GTT_TITLE = 0
Private Const PE_GTT_SUBTITLE = 1
Private Const PE_GTT_FOOTNOTE = 2
Private Const PE_GTT_SERIESTITLE = 3
Private Const PE_GTT_GROUPSTITLE = 4
Private Const PE_GTT_XAXISTITLE = 5
Private Const PE_GTT_YAXISTITLE = 6
Private Const PE_GTT_ZAXISTITLE = 7

' graph text fonts
Private Const PE_GTF_TITLEFONT = 0
Private Const PE_GTF_SUBTITLEFONT = 1
Private Const PE_GTF_FOOTNOTEFONT = 2
Private Const PE_GTF_GROUPSTITLEFONT = 3
Private Const PE_GTF_DATATITLEFONT = 4
Private Const PE_GTF_LEGENDFONT = 5
Private Const PE_GTF_GROUPLABELSFONT = 6
Private Const PE_GTF_DATALABELSFONT = 7

Private Const PE_FACE_NAME_LEN = 64

' Graph text max length
Private Const PE_GRAPH_TEXT_LEN = 128

Private Type PEFontColorInfo
    StructSize As Integer
    faceName As String * PE_FACE_NAME_LEN       ' empty string for no change
    fontFamily As Integer       ' FF_DONTCARE for no change
    fontPitch As Integer        ' DEFAULT_PITCH for no change
    charSet As Integer          ' DEFAULT_CHARSET for no change
    pointSize As Integer        ' 0 for no change
    isItalic As Integer         ' BOOL value, except use PE_UNCHANGED for no change.
    isUnderlined As Integer     ' BOOL value, except use PE_UNCHANGED for no change.
    isStruckOut As Integer      ' BOOL value, except use PE_UNCHANGED for no change.
    weight As Integer           ' 0 for no change
    color As Long               ' COLORREF - PE_UNCHANGED_COLOR for no change.
    twipSize As Integer         ' Font size in twips, 0 for no change.
                                ' Use one of pointSize or twipSize. If both pointSize and twipSize
                                ' are non-zero, twipSize will be used and pointSize will be ignored.
End Type

Private Const PE_SIZEOF_FONT_COLOR_INFO = PE_WORD_LEN + PE_FACE_NAME_LEN + (9 * PE_WORD_LEN) + PE_LONG_LEN

' titleType - PE_GTT_*
' title - HANDLE
Private Declare Function PEGetGraphTextInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, ByVal titleType As Integer, Title As Long, titleLength As Integer) As Integer
Private Declare Function PESetGraphTextInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, ByVal titleType As Integer, ByVal Title As String) As Integer

' enable/disable graph default titles
'
' titleType - PE_GTT_*
'
Private Declare Function PESetGraphTextDefaultOption Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, ByVal titleType As Integer, ByVal useDefault As Long) As Integer
Private Declare Function PEGetGraphTextDefaultOption Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, ByVal titleType As Integer, useDefault As Long) As Integer

' graph font
' titleFontType - PE_GTF_*
Private Declare Function PEGetGraphFontInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, ByVal titleFontType As Integer, fontColourInfo As PEFontColorInfo) As Integer
Private Declare Function PESetGraphFontInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, ByVal titleFontType As Integer, fontColourInfo As PEFontColorInfo) As Integer

' graph options
Private Const PE_GLP_PLACEUPPERRIGHT = 0
Private Const PE_GLP_PLACEBOTTOMCENTER = 1
Private Const PE_GLP_PLACETOPCENTER = 2
Private Const PE_GLP_PLACERIGHT = 3
Private Const PE_GLP_PLACELEFT = 4

' legend layout
'
Private Const PE_GLL_PERCENTAGE = 0
Private Const PE_GLL_AMOUNT = 1
Private Const PE_GLL_CUSTOM = 2    ' for PEGetGraphOptionInfo, do not use in PESetGraphOptionInfo.

' bar sizes
Private Const PE_GBS_MINIMUMBARSIZE = 0
Private Const PE_GBS_SMALLBARSIZE = 1
Private Const PE_GBS_AVERAGEBARSIZE = 2
Private Const PE_GBS_LARGEBARSIZE = 3
Private Const PE_GBS_MAXIMUMBARSIZE = 4

' mmm, pie sizes
Private Const PE_GPS_MINIMUMPIESIZE = 64
Private Const PE_GPS_SMALLPIESIZE = 48
Private Const PE_GPS_AVERAGEPIESIZE = 32
Private Const PE_GPS_LARGEPIESIZE = 16
Private Const PE_GPS_MAXIMUMPIESIZE = 0

' detached pie slice
Private Const PE_GDPS_NODETACHMENT = 0
Private Const PE_GDPS_SMALLESTSLICE = 1
Private Const PE_GDPS_LARGESTSLICE = 2

' marker sizes
Private Const PE_GMS_SMALLMARKERS = 0
Private Const PE_GMS_MEDIUMSMALLMARKERS = 1
Private Const PE_GMS_MEDIUMMARKERS = 2
Private Const PE_GMS_MEDIUMLARGEMARKERS = 3
Private Const PE_GMS_LARGEMARKERS = 4

' marker shapes
Private Const PE_GMSP_RECTANGLESHAPE = 1
Private Const PE_GMSP_CIRCLESHAPE = 4
Private Const PE_GMSP_DIAMONDSHAPE = 5
Private Const PE_GMSP_TRIANGLESHAPE = 8

' chart color
Private Const PE_GCR_COLORCHART = 0
Private Const PE_GCR_BLACKANDWHITECHART = 1

' chart data points
Private Const PE_GDP_NONE = 0
Private Const PE_GDP_SHOWLABEL = 1
Private Const PE_GDP_SHOWVALUE = 2

' number formats
Private Const PE_GNF_NODECIMAL = 0
Private Const PE_GNF_ONEDECIMAL = 1
Private Const PE_GNF_TWODECIMAL = 2
Private Const PE_GNF_CURRENCYNODECIMAL = 3
Private Const PE_GNF_CURRENCYTWODECIMAL = 4
Private Const PE_GNF_PERCENTNODECIMAL = 5
Private Const PE_GNF_PERCENTONEDECIMAL = 6
Private Const PE_GNF_PERCENTTWODECIMAL = 7

' viewing angles
Private Const PE_GVA_STANDARDVIEW = 1
Private Const PE_GVA_TALLVIEW = 2
Private Const PE_GVA_TOPVIEW = 3
Private Const PE_GVA_DISTORTEDVIEW = 4
Private Const PE_GVA_SHORTVIEW = 5
Private Const PE_GVA_GROUPEYEVIEW = 6
Private Const PE_GVA_GROUPEMPHASISVIEW = 7
Private Const PE_GVA_FEWSERIESVIEW = 8
Private Const PE_GVA_FEWGROUPSVIEW = 9
Private Const PE_GVA_DISTORTEDSTDVIEW = 10
Private Const PE_GVA_THICKGROUPSVIEW = 11
Private Const PE_GVA_SHORTERVIEW = 12
Private Const PE_GVA_THICKSERIESVIEW = 13
Private Const PE_GVA_THICKSTDVIEW = 14
Private Const PE_GVA_BIRDSEYEVIEW = 15
Private Const PE_GVA_MAXVIEW = 16

Private Type PEGraphOptionInfo
    StructSize As Integer

    graphColour As Integer      ' PE_GCR_*, PE_UNCHANGED for no change
        
    ShowLegend As Integer       ' BOOL, PE_UNCHANGED for no change
    legendPosition As Integer   ' PE_GLP_*, if showLegend == 0, means no legend

' pie charts and doughut charts
    pieSize As Integer  ' PE_GPS_*, PE_UNCHANGED for no change
    detachedPieSlice As Integer ' PE_GDPS_* or PE_UNCHANGED for no change

' bar chart
    barSize As Integer  ' PE_GBS_*, PE_UNCHANGED for no change
    VerticalBars As Integer     ' BOOL, PE_UNCHANGED for no change

' markers (used for line and bar charts)
    markerSize As Integer       ' PE_GMS_*, PE_UNCHANGED for no change
    markerShape As Integer      ' PE_GMSP_*, PE_UNCHANGED for no change

' data points
    dataPoints  As Integer      ' PE_GDP_*, PE_UNCHANGED for no change
    dataValueNumberFormat As Integer    ' PE_GNF_*, PE_UNCHANGED for no change
' 3d
    viewingAngle As Integer     ' PE_GVA_*, PE_UNCHANGED for no change

    legendLayout As Integer     ' PE_GLL_*
End Type

Private Const PE_SIZEOF_GRAPH_OPTION_INFO = (14 * PE_WORD_LEN)


Private Declare Function PEGetGraphOptionInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, graphOptionInfo As PEGraphOptionInfo) As Integer
Private Declare Function PESetGraphOptionInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, graphOptionInfo As PEGraphOptionInfo) As Integer

' graph axes
Private Const PE_GGT_NOGRIDLINES = 0
Private Const PE_GGT_MINORGRIDLINES = 1
Private Const PE_GGT_MAJORGRIDLINES = 2
Private Const PE_GGT_MAJORANDMINORGRIDLINES = 3

' axis division method
Private Const PE_ADM_AUTOMATIC = 0
Private Const PE_ADM_MANUAL = 1

Private Type PEGraphAxisInfo
    StructSize As Integer

    groupAxisGridLine As Integer        ' PE_GGT_*, PE_UNCHANGED for no change
    dataAxisYGridLine As Integer        ' PE_GGT_*, PE_UNCHANGED for no change
    dataAxisY2GridLine As Integer       ' PE_GGT_*, PE_UNCHANGED for no change
    seriesAxisGridline As Integer       ' PE_GGT_*, PE_UNCHANGED for no change

    dataAxisYMinValue As Double
    dataAxisYMaxValue As Double
    dataAxisY2MinValue As Double
    dataAxisY2MaxValue As Double
    seriesAxisMinValue As Double
    seriesAxisMaxValue As Double

    dataAxisYNumberFormat As Integer    ' PE_GNF_*, PE_UNCHANGED for no change
    dataAxisY2NumberFormat As Integer   ' PE_GNF_*, PE_UNCHANGED for no change
    seriesAxisNumberFormat As Integer   ' PE_GNF_*, PE_UNCHANGED for no change

    dataAxisYAutoRange As Integer       ' BOOL, PE_UNCHANGED for no change
    dataAxisY2AutoRange As Integer      ' BOOL, PE_UNCHANGED for no change
    seriesAxisAutoRange As Integer      ' BOOL, PE_UNCHANGED for no change

    dataAxisYAutomaticDivision As Integer       ' PE_ADM_* or PE_UNCHANGED for no change
    dataAxisY2AutomaticDivision As Integer      ' PE_ADM_* or PE_UNCHANGED for no change
    seriesAxisAutomaticDivision As Integer      ' PE_ADM_* or PE_UNCHANGED for no change

    dataAxisYManualDivision As Long     ' if dataAxisYAutomaticDivision is PE_ADM_AUTOMATIC, this field is ignored
    dataAxisY2ManualDivision As Long    ' if dataAxisY2AutomaticDivision is PE_ADM_AUTOMATIC, this field is ignored
    seriesAxisManualDivision As Long    ' if seriesAxisAutomaticDivision is PE_ADM_AUTOMATIC, this field is ignored

    dataAxisYAutoScale As Integer       ' BOOL, PE_UNCHANGED for no change
    dataAxisY2AutoScale As Integer      ' BOOL, PE_UNCHANGED for no change
    seriesAxisAutoScale As Integer      ' BOOL, PE_UNCHANGED for no change
End Type

Private Const PE_SIZEOF_GRAPH_AXIS_INFO = (5 * PE_WORD_LEN) + (6 * PE_DOUBLE_LEN) + (9 * PE_WORD_LEN) + (3 * PE_LONG_LEN) + (3 * PE_WORD_LEN)


Private Declare Function PEGetGraphAxisInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, graphAxisInfo As PEGraphAxisInfo) As Integer
Private Declare Function PESetGraphAxisInfo Lib "crpe32.dll" (ByVal printJob As Integer, ByVal sectionN As Integer, ByVal GraphN As Integer, graphAxisInfo As PEGraphAxisInfo) As Integer

' Subreport(s)
Private Declare Function PEOpenSubreport Lib "crpe32.dll" (ByVal parentJob%, ByVal subreportName$) As Integer
Private Declare Function PECloseSubreport Lib "crpe32.dll" (ByVal printJob%) As Integer

' Formula Syntax

Private Const PE_FS_SIZE = 2

' Syntax Types
Private Const PE_FST_CRYSTAL = 0
Private Const PE_FST_BASIC = 1

Private Type PEFormulaSyntax
    StructSize As Integer               ' Set to PE_SIZEOF_FORMULA_SYNTAX
    FormulaSyntax(0 To 1) As Integer    ' PE_FS_* or PE_UNCHANGED.
End Type

Private Const PE_SIZEOF_FORMULA_SYNTAX = (3 * PE_WORD_LEN)

' PESetFormulaSyntax
' Use this API to set the syntax to use in the next (and all successive)
' formula API call(s).
' Set one of PE_FST_* into formulaSyntax[0];
' formulaSyntax[1] is reserved for internal use.
' ***Default Behaviour: If any Formula API is called before calling
'                      PESetFormulaSyntax then PE_FST_CRYSTAL is assumed.
Private Declare Function PESetFormulaSyntax Lib "crpe32.dll" (ByVal printJob As Integer, FormulaSyntax As PEFormulaSyntax) As Integer

' PEGetFormulaSyntax
' Indicates the syntax used by the formula addressed in the last formula API call.
' The syntax type is returned in formulaSyntax[0];
' formulaSyntax[1] is reserved for internal use.
' ***Default Behaviour: If this API is called before any Formula API is called
'                       then the values returned will be PE_UNCHANGED.
Private Declare Function PEGetFormulaSyntax Lib "crpe32.dll" (ByVal printJob As Integer, FormulaSyntax As PEFormulaSyntax) As Integer

Public Type crParamInfo
    Name As String
    Value As Variant
End Type

'GLOBAL VARIABLE DECLARATION FOR PRINTING OPTIONS
'Private Dev As crDEVMODE
Private WOpt As PEWindowOptions
Private PeReportOpt As PEReportOptions
Private ParaValInfo As PEParameterValueInfo
Private ParaInfo As PEValueInfo

Public Sub SetDefaultValues(Optional ShowGroupTree As Boolean = False) ', Optional FormIndex As Integer = 144)
    
    'Declare Function PESetParameterValueInfo Lib "crpe32.dll" (ByVal printJob%, ByVal parameterFieldName$, ByVal reportName$, valueInfo As PEParameterValueInfo) As Integer
    
    With ParaValInfo
        .StructSize = PE_SIZEOF_PARAMETER_VALUE_INFO
        .isNullable = PE_UNCHANGED              ' Boolean value or PE_UNCHANGED for no change.
        .disallowEditing = 1         ' Boolean value or PE_UNCHANGED for no change.
        .allowMultipleValues = PE_UNCHANGED ' Boolean value or PE_UNCHANGED for no change.
        .hasDiscreteValues = 1 ' PE_UNCHANGED for no change.
                                            ' 0 means has ranges, 1 means has discrete values
                                            ' 2 means has discrete and ranged values
        .partOfGroup = PE_UNCHANGED ' Boolean value or PE_UNCHANGED for no change.
        .groupNum = PE_UNCHANGED ' a group number or PE_UNCHANGED for no change.
        .mutuallyExclusiveGroup = PE_UNCHANGED ' Boolean value or PE_UNCHANGED for no change.
    End With
    
    With ParaInfo
        .StructSize = PE_SIZEOF_VALUE_INFO
        .valueType = PE_VI_DATE  'a PE_VI_ constant
        .viNumber = 0
        .viCurrency = 0
        .viBoolean = 0
        .viString = ""
        .viDate(0) = Year(Now) ' To 2) As Integer ' year, month, day
        .viDate(1) = Month(Now)
        .viDate(2) = Day(Now)
        .viDateTime(0) = Year(Now)  ' To 5) As Integer ' year, month, day, hour, minute, second
        .viDateTime(1) = Month(Now)
        .viDateTime(2) = Day(Now)
        .viDateTime(3) = 0
        .viDateTime(4) = 0
        .viDateTime(5) = 0
        .viTime(0) = 0 ' To 2) As Integer  ' hour, minute, second
        .viTime(1) = 0
        .viTime(2) = 0
        .viColor = 0
        .viInteger = 0
        .viC = 0
        .ignored = 0 'for 4 byte alignment. ignored.
        .viLong = 0
    End With
    
'    With Dev
'        .dmDefaultSource = 0
'        .dmFields = DM_PAPERSIZE Or DM_PAPERLENGTH Or DM_PAPERWIDTH
'        .dmPrintQuality = -1
'        .dmPaperSize = FormIndex
'        .dmCopies = 3
'    End With
    
    With WOpt
    .StructSize = PE_SIZEOF_WINDOW_OPTIONS 'initialize to PE_SIZEOF_WINDOW_OPTIONS

    .hasGroupTree = IIf(ShowGroupTree, 1, 0)       '0 or 1, except use PE_UNCHANGED for no change
    .canDrillDown = 0         '0 or 1, except use PE_UNCHANGED for no change
    .hasNavigationControls = 1 '0 or 1, except use PE_UNCHANGED for no change
    .hasCancelButton = 1 '0 or 1, except use PE_UNCHANGED for no change
    .hasPrintButton = 1      '0 or 1, except use PE_UNCHANGED for no change
    .hasExportButton = 0 '0 or 1, except use PE_UNCHANGED for no change
    .hasZoomControl = 1 '0 or 1, except use PE_UNCHANGED for no change
    .hasCloseButton = 1 '0 or 1, except use PE_UNCHANGED for no change
    .hasProgressControls = 1 '0 or 1, except use PE_UNCHANGED for no change
    .hasSearchButton = 1 '0 or 1, except use PE_UNCHANGED for no change
    .hasPrintSetupButton = 1 '0 or 1, except use PE_UNCHANGED for no change
    .hasRefreshButton = 1 '0 or 1, except use PE_UNCHANGED for no change
    .showToolbarTips = PE_UNCHANGED       ' BOOL value, except use PE_UNCHANGED for no change
                                     ' default is TRUE (*Show* tooltips on toolbar)
    .showDocumentTips = PE_UNCHANGED      ' BOOL value, except use PE_UNCHANGED for no change
                                     ' default is FALSE (*Hide* tooltips on document)
    .hasLaunchButton = 1      ' Launch Seagate Analysis button on toolbar.
                                     ' BOOL value, except use PE_UNCHANGED for no change
                                     ' default is FALSE
    End With
    
    
    With PeReportOpt
        .StructSize = PE_SIZEOF_REPORT_OPTIONS 'initialize to PE_SIZEOF_REPORT_OPTIONS
        .saveDataWithReport = 0              'BOOL value, except use PE_UNCHANGED for no change
        .saveSummariesWithReport = 0 'BOOL value, except use PE_UNCHANGED for no change
        .useIndexForSpeed = 1 'BOOL value, except use PE_UNCHANGED for no change
        .translateDOSStrings = 1 'BOOL value, except use PE_UNCHANGED for no change
        .translateDosMemos = 1 'BOOL value, except use PE_UNCHANGED for no change
        .convertDateTimeType = PE_UNCHANGED 'a PE_RPTOPT_ value, except use PE_UNCHANGED for no change
        .convertNullFieldToDefault = PE_UNCHANGED       'BOOL value, except use PE_UNCHANGED for no change
        .morePrintEngineErrorMessages = PE_UNCHANGED 'BOOL value, except use PE_UNCHANGED for no change
        .caseInsensitiveSQLData = PE_UNCHANGED 'BOOL value, except use PE_UNCHANGED for no change
        .verifyOnEveryPrint = PE_UNCHANGED 'BOOL value, except use PE_UNCHAGED for no change
        .zoomMode = PE_UNCHANGED 'a PE_ZOOM_ constant, except use PE_UNCHANGED for no change
        .hasGroupTree = IIf(ShowGroupTree, 1, 0)   'BOOL value, except use PE_UNCHANGED for no change
        .dontGenerateDataForHiddenObjects = PE_UNCHANGED ' BOOL value, except use PE_UNCHANGED for no change
        .performGroupingOnServer = PE_UNCHANGED ' BOOL value, except use PE_UNCHANGED for no change
        .doAsyncQuery = 0 ' BOOL value, except use PE_UNCHANGED for no change
        .promptMode = PE_RPTOPT_PROMPT_NORMAL ' PE_RPTOPT_PROMPT_NONE, PE_RPTOPT_PROMPT_NORMAL, PE_RPTOPT_PROMPT_ALWAYS, use PE_UNCHANGED for no change
        .SelectDistinctRecords = PE_UNCHANGED ' BOOL value, except use PE_UNCHANGED for no change
    End With
    
End Sub

Public Function ShowError(ByVal JobNum As Integer, Optional ByVal ModuleName As String = "", Optional ByVal CloseJob As Boolean = True) As String
    Dim TextHand As Long, RetVal As Long, ErrorNum As Integer
    Dim TextSize As String * 255
    Dim Buffer As String * 255
    Dim ReturnString As String * 500
    
    ErrorNum = PEGetErrorCode(JobNum)
    RetVal = PEGetErrorText(JobNum, TextHand, 1084)
    RetVal = PEGetHandleString(TextHand, TextSize, 255)
    
    If Trim(ModuleName) <> "" Then
        ReturnString = "An Error Occurd in Module [ " & ModuleName & " ] With No. " & ErrorNum & vbCrLf & _
                   "The Error Says That : " & vbCrLf & vbCrLf & TextSize
    Else
        ReturnString = "An Error Occurd With No. " & ErrorNum & vbCrLf & _
                   "The Error Says That : " & vbCrLf & vbCrLf & TextSize
    End If
    
    If CloseJob = True Then
        RetVal = PEClosePrintJob(JobNum)
    End If
    
    ShowError = ReturnString
    
           
End Function
Public Sub PrintCrystalReport(ByVal ReportPath As String, ByVal sProvider As String, ByVal sDllName As String, _
    ByVal sServer As String, sDBName As String, ByVal sUserID As String, ByVal sPassword As String, _
    Parameters() As crParamInfo, prt As Printer, _
    Optional ByVal Integrated_Security As Boolean = True, Optional ByVal showPreview As Boolean = True, _
    Optional ByVal numCopies As Integer = 1, Optional ByVal FormIndex As Integer = -1, _
    Optional ByVal nPaperSource As Integer = 1, Optional ByVal nOrientation As Integer = -1, _
    Optional ByVal nPrintQuality As Integer = -2, Optional ByVal hwndParent As Long = 0, _
    Optional ByVal ShowGroupTree As Boolean)
    'debug.Assert
    Dim iLoop As Integer, i As Integer
    Dim iresult As Integer
    Dim NumParams As Integer, hwndReport As Long
    Dim MainJob As Integer
    Dim MyPFInfo As PEParameterFieldInfo
    Dim MyVInfo As PEValueInfo
    'Procedurs to Format the ReportPath and ReportName values
        
    SetDefaultValues ShowGroupTree ', FormIndex
    'set Default values for report (See it very important)
    
    ' Initialize parameter field info and value info structure sizes
    MyPFInfo.StructSize = PE_SIZEOF_PARAMETER_FIELD_INFO
    
    MyVInfo.StructSize = PE_SIZEOF_VALUE_INFO
    
    ' Open print engine
    iresult = PEOpenEngine()
    If iresult = 0 Then
        MsgBox "Unable to Open Report Engine", vbCritical, "FACOR ERP: VERIFYING REPORT ENGINE"
        Exit Sub
    End If
        
    ' Open the selected report
    MainJob = PEOpenPrintJob(ReportPath)
    If MainJob = 0 Then
        MsgBox ShowError(MainJob, "PEOpenPrintJob")
        Exit Sub
    End If
    ' Get the number of parameters in the report
   ' MsgBox Printer.Port
'     iresult = crPEGetSelectedPrinter(MainJob, Printer.DriverName, Printer.DeviceName, Printer.Port, Dev)
'    iresult = PESelectPrinter(MainJob, Printer.DriverName, Printer.DeviceName, Printer.Port, Dev)
Dim ptrDevMode As Long, pDevMode As DEVMODE_NEW
    pDevMode.dmSize = Len(pDevMode)
Dim DriverHandle As Long, DriverLength As Integer, sDDL As String
Dim PrinterHandle As Long, PrinterLength As Integer
Dim PortHandle As Long, PortLength As Integer

'     iresult = crPEGetSelectedPrinter(MainJob, Printer.DriverName, Printer.DeviceName, Printer.Port, pDevMode)
    iresult = PEGetSelectedPrinter(MainJob, DriverHandle, DriverLength, PrinterHandle, PrinterLength, PortHandle, PortLength, ptrDevMode)
    If iresult = 1 Then
        CopyMemory pDevMode, ByVal ptrDevMode, Len(pDevMode)
        sDDL = Space$(DriverLength)
        iresult = PEGetHandleString(DriverHandle, sDDL, DriverLength)
        sDDL = Space$(PrinterLength)
        iresult = PEGetHandleString(PrinterHandle, sDDL, PrinterLength)
    Else
        MsgBox ShowError(MainJob, "PEGetSelectedPrinter")
        Exit Sub
    End If
    With pDevMode
'         .dmDeviceName = Printer.DeviceName & Chr(0)
'        .dmDefaultSource = 284 ' 0'284=Tractor
        If nPaperSource <> -1 Then
            .dmDefaultSource = nPaperSource
        End If
'        .dmFields = DM_PAPERSIZE Or DM_PAPERLENGTH Or DM_PAPERWIDTH Or DM_COPIES Or DM_DEFAULTSOURCE
''        .dmFields = .dmFields Or DM_ORIENTATION
'        .dmOrientation = DMORIENT_LANDSCAPE
        If nOrientation <> -1 Then
            .dmOrientation = nOrientation
        End If
'            .dmPrintQuality = -1 'Draft Qaulity
        If nPrintQuality <> -2 Then
            .dmPrintQuality = nPrintQuality
        End If
        If FormIndex <> -1 Then
            .dmPaperSize = FormIndex
        End If
        .dmCopies = numCopies
    End With

'     iresult = crPESelectPrinter(MainJob, prt.DriverName, prt.DeviceName, prt.Port, pDevMode)
     iresult = PESelectPrinter(MainJob, prt.DriverName, prt.DeviceName, prt.Port, pDevMode)

    If iresult = 0 Then
        MsgBox ShowError(MainJob, "PESelectPrinter")
        Exit Sub
    End If
Dim nTables As Integer, iTable As Integer, sTable As String
     Dim LogOnInfo As PELogOnInfo
        LogOnInfo.StructSize = PE_SIZEOF_LOGON_INFO
    
'''    iresult = crPELogOnServer("crdb_ado.dll", "", "", "sa", "")
'''    iresult = crPELogOnServer(sDllName, sServer, sDBName, sUserID, sPassword)
''        LogOnInfo.ServerName = sServer
''        LogOnInfo.DatabaseName = sDBName
''        LogOnInfo.UserID = sUserID
''        LogOnInfo.Password = sPassword
''
''    iresult = PELogOnServer(sDllName, LogOnInfo)
    
        nTables = PEGetNTables(MainJob)
For iTable = 0 To nTables - 1
    iresult = PEGetNthTableLogOnInfo(MainJob, iTable, LogOnInfo)
'    iresult = crPEGetNthTableLogOnInfo(MainJob, iTable, _
'             LogOnInfo.ServerName, _
'             LogOnInfo.DatabaseName, LogOnInfo.UserID)
    If iresult = 0 Then
            MsgBox ShowError(MainJob, "LogOn", False)
        Exit For
    End If
    If sProvider = "MSDASQL.1" Then 'MSACCESS
        LogOnInfo.ServerName = sDBName & Chr(0)
        LogOnInfo.DatabaseName = sDBName & Chr(0)
        LogOnInfo.UserID = sUserID & Chr(0)
        LogOnInfo.Password = sPassword & Chr(0)
    Else
        LogOnInfo.ServerName = sServer & Chr(0)
        LogOnInfo.DatabaseName = sDBName & Chr(0)
        LogOnInfo.UserID = sUserID & Chr(0)
        LogOnInfo.Password = sPassword & Chr(0)
    End If
'    iresult = crPESetNthTableLogOnInfo(MainJob, iTable, _
'             LogOnInfo.ServerName, _
'             LogOnInfo.DatabaseName, LogOnInfo.UserID, sPassword, 1)
    iresult = PESetNthTableLogOnInfo(MainJob, iTable, _
             LogOnInfo, 1)
    If iresult = 0 Then
            MsgBox ShowError(MainJob, "LogOn", False)
        
    End If
'            sTable = Space$(256)
'   iresult = crPEGetNthTableLocation(MainJob, iTable, sTable)
'   iresult = crPESetNthTableLocation(MainJob, iTable, Trim$(sTable))
    Dim TableLocation As PETableLocation
        TableLocation.StructSize = PE_SIZEOF_TABLE_LOCATION
   iresult = PEGetNthTableLocation(MainJob, iTable, TableLocation)
   If iresult = 0 Then
            MsgBox ShowError(MainJob, "LogOn", False)
    End If
    Dim sConn As String
      
    If sProvider = "MSDASQL.1" Then 'MSACCESS
'        Provider=Microsoft.Jet.OLEDB.4.0;;Data Source=E:\Joshy\BankSoft\Controls\CrystalReportAPI\NWIND.MDB;;User ID=Admin;;Password=;;Jet System Database=;;Jet Database Password=;;Database Type=Access;;Locale Identifier=1033;;OLE DB Services=-6;;PreQEServerType=OLE DB (ADO);;PreQEServerName=E:\Joshy\BankSoft\Controls\CrystalReportAPI\NWIND.MDB;;PreQEDatabaseName=E:\Joshy\BankSoft\Controls\CrystalReportAPI\NWIND.MDB;;UserId=Admin
        'Provider=MSDASQL.1;DBQ=" & DataPath & ";PWD=12828102120824;UID=admin;Persist Security Info=False;DefaultDir=" & Mid(DataPath, 1, InStrRev(DataPath, "\") - 1) & ";Driver={Microsoft Access Driver (*.mdb)};DriverId=25;FIL=MS Access;MaxBufferSize=2048;MaxScanRows=8;PageTimeout=5;SafeTransactions=0;Threads=3;
        sConn = "Provider=" & sProvider & ";;"
        sConn = sConn & "DBQ=" & sDBName & ";;"
        sConn = sConn & "UID=" & sUserID & ";;"
        sConn = sConn & "PWD=" & sPassword & ";;"
        sConn = sConn & "Persist Security Info=" & IIf(Integrated_Security, "True", "False") & ";;"
        sConn = sConn & "DefaultDir=" & Mid(sDBName, 1, InStrRev(sDBName, "\") - 1) & ";;"
        sConn = sConn & "Driver={Microsoft Access Driver (*.mdb)};;DriverId=25;;"
        sConn = sConn & "FIL=MS Access;;"
        sConn = sConn & "MaxBufferSize=2048;;MaxScanRows=8;;PageTimeout=5;;"
        sConn = sConn & "SafeTransactions=0;;Threads=3;;"
        sConn = sConn & Chr(0)
    Else
        'sProvider="SQLOLEDB.1"'""SQLOLEDB
        'Provider=SQLOLEDB;Data Source=" & ServerAddress & ";Initial Catalog=" & DataCatalog & ";;User ID=sa;;Password=" & MainConnectionPwd & ";;Integrated Security=0;;Locale Identifier=1033;;Connect Timeout=15;;General Timeout=0;;OLE DB Services=-5;;Current Language=;;Initial File Name=;;Use Encryption for Data=0;;Replication server name connect option=;;Tag with column collation when possible=0
        'Provider=SQLNCLI10.1;Data Source=" & ServerAddress & ";Initial Catalog=" & DataCatalog & ";;User ID=sa;;Password=" & MainConnectionPwd & ";;Integrated Security=0;;Locale Identifier=1033;;Connect Timeout=15;;General Timeout=0;;OLE DB Services=-5;;Current Language=;;Initial File Name=;;Use Encryption for Data=0;;Replication server name connect option=;;Tag with column collation when possible=0
        
        sConn = "Provider=" & sProvider & ";;"
        sConn = sConn & "Data Source=" & sServer & ";;"
        sConn = sConn & "Initial Catalog=" & sDBName & ";;"
        sConn = sConn & "User ID=" & sUserID & ";;"
        sConn = sConn & "Password=" & sPassword & ";;"
        sConn = sConn & "Integrated Security=" & IIf(Integrated_Security, 1, 0) & ";;"
        sConn = sConn & "Locale Identifier=1033;;"
        sConn = sConn & "Connect Timeout=15;;General Timeout=0;;"
        sConn = sConn & "OLE DB Services=-5;;Current Language=;;"
        sConn = sConn & "Initial File Name=;;Use Encryption for Data=0;;"
        sConn = sConn & "Replication server name connect option=;;"
        sConn = sConn & "Tag with column collation when possible=0;;"
        sConn = sConn & "PreQEServerType=OLE DB (ADO);;"
        sConn = sConn & "PreQEServerName=" & sServer & ";;"
        sConn = sConn & "PreQEDatabaseName=" & sDBName & ";;"
        sConn = sConn & Chr(0)
    End If
        TableLocation.ConnectBuffer = sConn
        TableLocation.Location = Trim$(Replace$(TableLocation.Location, Chr(0), "")) & Chr(0)
        TableLocation.SubLocation = Trim$(Replace$(TableLocation.SubLocation, Chr(0), "")) & Chr(0)
   iresult = PESetNthTableLocation(MainJob, iTable, TableLocation)
     If iresult = 0 Then
            MsgBox ShowError(MainJob, "LogOn", False)
    End If
Next
    Dim Param As Variant
'Fetch Nos. of Parameters used in this Report
    NumParams = PEGetNParameterFields(MainJob)
    ' Loop through each parameter field and get and set the current value
For iLoop = 0 To (NumParams - 1)
' Get the selected parameter field value
    iresult = PEGetNthParameterField(MainJob, iLoop, MyPFInfo)
' Convert the parameter field info structure current value member to a value info structure
'        If MyPFInfo.needsCurrentValue = 0 Then 'This param is either linked or not used in Report
'        Else
    For i = 0 To UBound(Parameters)
'''            If InStr(MyPFInfo.Name, Chr(0)) Then
'''                MyPFInfo.Name = Mid$(MyPFInfo.Name, 1, InStr(MyPFInfo.Name, Chr(0)) - 1)
'''            End If
        If Trim$(Replace$(MyPFInfo.Name, Chr(0), "")) = Parameters(i).Name Then
            iresult = PEConvertPFInfoToVInfo(MyPFInfo.currentValue, MyPFInfo.valueType, MyVInfo)
            ' Check parameter field value type and place value into appropriate value info structure member
            Select Case MyPFInfo.valueType
        
                Case PE_PF_NUMBER     ' Number parameter
                    MyVInfo.viNumber = Parameters(i).Value ' Parameters(iLoop)
                Case PE_PF_CURRENCY ' Currency parameter
                    MyVInfo.viCurrency = Parameters(i).Value ' Parameters(iLoop)
                Case PE_PF_BOOLEAN ' Boolean parameter
                    MyVInfo.viBoolean = Parameters(i).Value 'Parameters(iLoop)
                Case PE_PF_STRING ' String parameter
                    MyVInfo.viString = Parameters(i).Value 'Parameters(iLoop)
                Case PE_PF_DATE ' Date parameter
                    MyVInfo.viDate(0) = Year(Parameters(i).Value) 'Parameters(iLoop)) ' 2004
                    MyVInfo.viDate(1) = Month(Parameters(i).Value) 'Parameters(iLoop)) '10
                    MyVInfo.viDate(2) = Day(Parameters(i).Value) 'Parameters(iLoop))
                Case PE_PF_DATETIME ' DateTime Parameter
                    MyVInfo.viDateTime(0) = Year(Parameters(i).Value) 'Parameters(iLoop))
                    MyVInfo.viDateTime(1) = Month(Parameters(i).Value) 'Parameters(iLoop))
                    MyVInfo.viDateTime(2) = Day(Parameters(i).Value) 'Parameters(iLoop))
                    MyVInfo.viDateTime(3) = Hour(Parameters(i).Value) 'Parameters(iLoop))
                    MyVInfo.viDateTime(4) = Minute(Parameters(i).Value) 'Parameters(iLoop))
                    MyVInfo.viDateTime(5) = Second(Parameters(i).Value) 'Parameters(iLoop))
                Case PE_PF_TIME 'Time Parameter
                    MyVInfo.viTime(0) = Hour(Parameters(i).Value) 'Parameters(iLoop))
                    MyVInfo.viTime(1) = Minute(Parameters(i).Value) 'Parameters(iLoop))
                    MyVInfo.viTime(2) = Second(Parameters(i).Value) 'Parameters(iLoop))
            End Select
            ' Convert value info structure to parameter field info current value member
            iresult = PEConvertVInfoToPFInfo(MyVInfo, MyPFInfo.valueType, MyPFInfo.currentValue)
            ' Set current value flag
            MyPFInfo.CurrentValueSet = 1
            ' Set the parameter field value
            iresult = PESetNthParameterField(MainJob, iLoop, MyPFInfo)
            Exit For
        End If
    Next
Next iLoop
    
    
   
    'Check if Any Selection Formula is supplied
        Dim txtHand As Long
        Dim Query As String
        Dim RptStrSelectionFormula As String
        Dim RptQueryString As String
        RptStrSelectionFormula = Space(22886)
        RptQueryString = Space(22886)
        'Get the Predefined Selection Formula of Report
        
        i = PEGetSelectionFormula(MainJob, txtHand, Len(RptStrSelectionFormula))
        i = PEGetHandleString(txtHand, RptStrSelectionFormula, Len(RptStrSelectionFormula))
            txtHand = 0
        i = PEGetSQLQuery(MainJob, txtHand, Len(RptQueryString))
        i = PEGetHandleString(txtHand, RptQueryString, Len(RptQueryString))
        ' If User have also supplied the Selection Formula
'        If Trim(strSelectionFormula) <> "" Then
'
'            If Trim(RptStrSelectionFormula) = "" Then 'If the Report Formula is Blank
'                RptStrSelectionFormula = Trim(strSelectionFormula)  'iresult = PESetSelectionFormula(MainJob, strSelectionFormula)
'            Else
'                RptStrSelectionFormula = Trim(RptStrSelectionFormula) & " AND ( " & Trim(strSelectionFormula) & " )"
'                'iresult = PESetSelectionFormula(MainJob, strSelectionFormula)
'            End If
'        Else 'if No Selection Formula is specified
'             RptStrSelectionFormula = Trim(RptStrSelectionFormula)
'        End If
    
'    If Trim(strQueryString) <> "" Then
'        If Trim(RptQueryString) = "" Then
'            RptQueryString = Trim(strQueryString)
'        Else
'            RptQueryString = Trim(strQueryString)
'
'        End If
'
'    Else
'            RptQueryString = Trim(RptQueryString)
'    End If
    
    iresult = PESetSQLQuery(MainJob, Trim$(RptQueryString))
    'After Setting the Query String
    'Again Set The Selection Formula for the Report
    'Be aware that query String always overwrites the Selection Formula
    'So set it again
    iresult = PESetSelectionFormula(MainJob, Trim$(RptStrSelectionFormula))
      
    iresult = PEShowPrintControls(MainJob, 1)
    iresult = PESetWindowOptions(MainJob, WOpt)
    iresult = PESetReportOptions(MainJob, PeReportOpt)
    iresult = PESetAllowPromptDialog(MainJob, False)
    'Do Not Remove Below Commented Lines (For Win 2K users)
    '12045 -- 8625
    'Or WS_MAXIMIZEBOX Or WS_MINIMIZE Or WS_MINIMIZEBOX
If showPreview = True Then
    iresult = PEOutputToWindow(MainJob, "Print Preview", 0, 0, 0, 0, WS_VISIBLE Or WS_MAXIMIZE Or WS_SYSMENU, hwndParent)
Else
    iresult = PEOutputToPrinter(MainJob, numCopies)
End If
    'error handling on the output to window
    If iresult = 0 Then
        MsgBox ShowError(MainJob, "PEOutputToWindow")
    End If
    
    'start the print job
    'CR.Action = 1
'    iresult = PEStartPrintJob(MainJob, 1)
    iresult = PEStartPrintJob(MainJob, 0)
    
    If iresult = 0 Then
        MsgBox ShowError(MainJob, "PEOutputToWindow")
    End If
Dim bJobCanceled As Boolean, JobInfo As PEJobInfo
        JobInfo.StructSize = PE_SIZEOF_JOB_INFO
'    iresult = PEGetJobStatus4(MainJob, JobInfo4)
    iresult = PEGetJobStatus(MainJob, JobInfo)
    If iresult = 5 Then
        bJobCanceled = True
        Exit Sub
    Else
        hwndReport = PEGetWindowHandle(MainJob)
    End If
    iresult = PEGetNPages(MainJob)
    iresult = PEGetJobStatus(MainJob, JobInfo)
    If iresult = 5 Then
        bJobCanceled = True
    End If
    If iresult = PE_JOBCOMPLETED Then
        'Job Completed
    End If
'    strQueryString = ""
'    strSelectionFormula = ""
    RptStrSelectionFormula = ""
    RptQueryString = ""
       

    ' Close the print job
    PEClosePrintJob (MainJob)
'    iresult = crPELogOffServer(sDllName, sServer, sDBName, sUserID, sPassword)
        LogOnInfo.ServerName = sServer
        LogOnInfo.DatabaseName = sDBName
        LogOnInfo.UserID = sUserID
        LogOnInfo.Password = sPassword
        
''    iresult = PELogOffServer(sDllName, LogOnInfo)

'    ' Close the engine
'    'This will Also close the Report
'    PECloseEngine
    
End Sub

