Attribute VB_Name = "modPaperSize"
Option Explicit
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Private Declare Sub CopyMemory Lib "kernel32" _
      Alias "RtlMoveMemory" ( _
      Destination As Any, _
      Source As Any, _
      ByVal Length As Long)

Private Const CCHDEVICENAME = 32
Private Const CCHFORMNAME = 32

Private Type DEVMODE
    dmDeviceName As String * CCHDEVICENAME
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCHFORMNAME
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFrequency As Long
End Type
Private Type PRINTER_INFO_1
        flags As Long
        pDescription As String
        pName As String
        pComment As String
End Type
Private Const PRINTER_ENUM_LOCAL = &H2 'Enumerate local printer objects.
Private Const PRINTER_ENUM_CONNECTIONS = &H4     'Enumerate printer connections previously added through RpcAddPerMachineConnection.
Private Const PRINTER_ENUM_NAME = &H8     'Enumerate printers on the print server, network domain, or a specific print provider.
Private Const PRINTER_ENUM_REMOTE = &H10    'Enumerate network printers and other print servers that are in the same domain as the print server.
Private Const PRINTER_ENUM_SHARED = &H20    'Only enumerate printers with the shared attribute set. This flag MUST be combined with one or more of the other flags.
Private Const PRINTER_ENUM_NETWORK = &H40    'Enumerate network printers that are in the same domain as the print server.
Private Declare Function EnumPrinters Lib "winspool.drv" Alias "EnumPrintersA" (ByVal flags As Long, ByVal Name As Long, ByVal Level As Long, pPrinterEnum As Long, ByVal cdBuf As Long, pcbNeeded As Long, pcReturned As Long) As Long
Private Declare Function lstrcpy Lib "kernel32.dll" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long
Private Declare Function lstrlen Lib "kernel32.dll" Alias "lstrlenA" (ByVal lpString As Long) As Long

Private Declare Function GetDefaultPrinterA Lib "winspool.drv" (ByVal str As String, pcbNeeded As Long) As Long
Private Declare Function SetDefaultPrinterA Lib "winspool.drv" (ByVal str As String) As Long
Private Const ERROR_FILE_NOT_FOUND = 2&
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Const PRINTER_ACCESS_ADMINISTER = &H4 'Printing-specific access rights for printers to perform administrative tasks ([MS-DTYP] ACCESS_MASK Bit 29).
Private Const PRINTER_ACCESS_USE = &H8 'Printing-specific access rights for printers to perform basic printing operations ([MS-DTYP] ACCESS_MASK Bit 28).
Private Const PRINTER_ACCESS_MANAGE_LIMITED = &H40 'Printing-specific access rights for printers to perform printer data management operations ([MS-DTYP] ACCESS_MASK Bit 25).<128>
Private Const PRINTER_ALL_ACCESS = &HF000C 'Access rights for printers to perform all administrative tasks and basic printing operations except synchronization. Combines WO (Write Owner), WD (Write DACL), RC (Read Control), and DE (Delete) of ACCESS_MASK with printing-specific PRINTER_ACCESS_ADMINISTER and printing-specific PRINTER_ACCESS_USE.
Private Const PRINTER_EXECUTE = &H20008 'Access rights for printers combining RC (Read Control) of ACCESS_MASK with printing-specific PRINTER_ACCESS_USE.
Private Const PRINTER_READ = &H20008 'Access rights for printers combining RC (Read Control) of ACCESS_MASK with printing-specific PRINTER_ACCESS_USE.
Private Const PRINTER_WRITE = &H20008 'Access rights for printers combining RC (Read Control) of ACCESS_MASK with printing-specific PRINTER_ACCESS_USE.
Private Type PRINTER_DEFAULTS
    pDatatype As String
    pDevMode As DEVMODE
    DesiredAccess As Long
End Type
Private Declare Function OpenPrinter Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, ByRef phPrinter As Long, ByRef pDefault As Any) As Long
Private Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long

Private Type SIZEL
    cX As Long
    cY As Long
End Type
' The two definitions for FORM_INFO_1 make the coding easier.
Private Type FORM_INFO_1
    flags As Long
    pName As Long            ' String
    Size As SIZEL
    ImageableArea As RECT
End Type
Private Type sFORM_INFO_1
    flags As Long
    pName As String
    Size As SIZEL
    ImageableArea As RECT
End Type
Private Declare Function EnumForms Lib "winspool.drv" Alias "EnumFormsA" _
        (ByVal hPrinter As Long, ByVal Level As Long, ByRef pForm As Any, _
        ByVal cbBuf As Long, ByRef pcbNeeded As Long, _
        ByRef pcReturned As Long) As Long
Private Declare Function AddForm Lib "winspool.drv" Alias "AddFormA" _
        (ByVal hPrinter As Long, ByVal Level As Long, pForm As Byte) As Long
Private Declare Function DeleteForm Lib "winspool.drv" Alias "DeleteFormA" _
        (ByVal hPrinter As Long, ByVal pFormName As String) As Long
' Optional functions not used in this sample, but may be useful.
Private Declare Function GetForm Lib "winspool.drv" Alias "GetFormA" _
        (ByVal hPrinter As Long, ByVal pFormName As String, _
        ByVal Level As Long, pForm As Byte, ByVal cbBuf As Long, _
        pcbNeeded As Long) As Long
Private Declare Function SetForm Lib "winspool.drv" Alias "SetFormA" _
        (ByVal hPrinter As Long, ByVal pFormName As String, _
        ByVal Level As Long, pForm As Byte) As Long
Private Declare Function DeviceCapabilities Lib "winspool.drv" _
   Alias "DeviceCapabilitiesA" (ByVal lpDeviceName As String, _
   ByVal lpPort As String, ByVal iIndex As Long, lpOutput As Any, _
   ByVal dev As Long) As Long
Private Declare Function DeviceCapabilitiesDev Lib "winspool.drv" Alias "DeviceCapabilitiesA" (ByVal lpDeviceName As String, ByVal lpPort As String, ByVal iIndex As Long, ByVal lpOutput As String, lpDevMode As DEVMODE) As Long

Private Const DC_BINS = 6
Private Const DC_BINNAMES = 12

Private hPrinter As Long
Public Function SetPrinterDefault(ByVal PrinterName As String) As Boolean
Dim ret As Long
ret = SetDefaultPrinterA(PrinterName)
    SetPrinterDefault = (ret = 1)
End Function
Public Function PrinterDefault() As String
Dim str As String, cb As Long, ret As Long
    ret = GetDefaultPrinterA("", cb)
        str = Space$(cb - 1) '-1 for Null Char
    ret = GetDefaultPrinterA(str, cb)
If GetLastError = ERROR_FILE_NOT_FOUND Then 'There is no default printer.
    str = ""
End If
    PrinterDefault = str
End Function
Function GetPrinteres(numprinters As Long, D() As String) As String()
    Dim longbuffer() As Long  ' resizable array receives information from the function
'    Dim printinfo  As PRINTER_INFO_1  ' values inside longbuffer() will be put into here
    Dim numbytes As Long  ' size in bytes of longbuffer()
    Dim numneeded As Long  ' receives number of bytes necessary if longbuffer() is too small
'    Dim numprinters As Long  ' receives number of printers found
    Dim c As Long, RetVal As Long  ' counter variable & return value
    Dim A() As String
 
    ' Get information about the local printers
    numbytes = 0 ' 3076  ' should be sufficiently big, but it may not be
    ReDim longbuffer(0 To numbytes / 4) As Long  ' resize array -- note how 1 Long = 4 bytes
    RetVal = EnumPrinters(PRINTER_ENUM_LOCAL Or PRINTER_ENUM_CONNECTIONS, 0, 1, ByVal 0&, 0, numneeded, numprinters)
    If RetVal = 0 Then  ' try enlarging longbuffer() to receive all necessary information
        numbytes = numneeded
        ReDim longbuffer(0 To numbytes / 4) As Long  ' make it large enough
        RetVal = EnumPrinters(PRINTER_ENUM_LOCAL Or PRINTER_ENUM_CONNECTIONS, 0, 1, longbuffer(0), numbytes, numneeded, numprinters)
        If RetVal = 0 Then ' failed again!
'            Debug.Print "Could not successfully enumerate the printes."
        End  ' abort program
    End If
    End If
    ' Convert longbuffer() data into printinfo()
    If numprinters <> 0 Then
'        ReDim printinfo(0 To numprinters - 1) As PRINTER_INFO_1 ' room for each printer
        ReDim A(numprinters - 1)
        ReDim D(numprinters - 1)
    End If
    For c = 0 To numprinters - 1  ' loop, putting each set of information into each element
        ' longbuffer(4 * c) = .flags, longbuffer(4 * c + 1) = .pDescription, etc.
        ' For each string, the string is first buffered to provide enough room, and then the string is copied.
'        printinfo(c).flags = longbuffer(4 * c)
'        printinfo(c).pDescription = Space(lstrlen(longbuffer(4 * c + 1)))
'        RetVal = lstrcpy(printinfo(c).pDescription, longbuffer(4 * c + 1))
'        printinfo(c).pName = Space(lstrlen(longbuffer(4 * c + 2)))
'        RetVal = lstrcpy(printinfo(c).pName, longbuffer(4 * c + 2))
'        printinfo(c).pComment = Space(lstrlen(longbuffer(4 * c + 3)))
'        RetVal = lstrcpy(printinfo(c).pComment, longbuffer(4 * c + 3))
            A(c) = Space(lstrlen(longbuffer(4 * c + 2)))
        RetVal = lstrcpy(A(c), longbuffer(4 * c + 2))
            D(c) = Space(lstrlen(longbuffer(4 * c + 1)))
        RetVal = lstrcpy(D(c), longbuffer(4 * c + 1))
        
    Next c
        Erase longbuffer
GetPrinteres = A
    Erase A
End Function
Private Sub PrinterCreate(ByVal DeviceName As String)
        If hPrinter <> 0 Then
            PrinterDestroy
        End If
Dim lResult As Long
Dim PDF As PRINTER_DEFAULTS
        PDF.DesiredAccess = PRINTER_ACCESS_ADMINISTER Or PRINTER_ACCESS_USE
        PDF.pDatatype = vbNullString
    lResult = OpenPrinter(DeviceName, hPrinter, PDF)
If lResult = 0 Then
     Exit Sub
End If
End Sub
Private Sub PrinterDestroy()
    If hPrinter <> 0 Then
        ClosePrinter hPrinter
        hPrinter = 0
    End If
End Sub
Private Function PtrCtoVbString(ByVal Add As Long) As String
Dim sTemp As String * 512, x As Long
On Error Resume Next
  x = lstrcpy(sTemp, ByVal Add)
  If (InStr(1, sTemp, Chr$(0)) = 0) Then
    PtrCtoVbString = ""
  Else
    PtrCtoVbString = Left$(sTemp, InStr(1, sTemp, Chr$(0)) - 1)
  End If
End Function
Public Function PrinterGetForms(ByVal DeviceName As String, Names() As String, SizeX() As Long, SizeY() As Long) As Long
    Dim NumForms As Long, i As Long
    Dim FI1 As FORM_INFO_1
    Dim aFI1() As FORM_INFO_1 ' Working FI1 array
    Dim temp() As Byte       ' Temp FI1 array
    Dim FormIndex As Integer
    Dim BytesNeeded As Long
    Dim RetVal As Long
            PrinterCreate DeviceName
    ReDim aFI1(1)
    ' First call retrieves the BytesNeeded.
    RetVal = EnumForms(hPrinter, 1, aFI1(0), 0&, BytesNeeded, NumForms)
    ReDim temp(BytesNeeded)
    ReDim aFI1(BytesNeeded / Len(FI1))
    ' Second call actually enumerates the supported forms.
    RetVal = EnumForms(hPrinter, 1, temp(0), BytesNeeded, BytesNeeded, _
            NumForms)
    Call CopyMemory(aFI1(0), temp(0), BytesNeeded)
        ReDim Names(NumForms - 1)
        ReDim SizeX(NumForms - 1)
        ReDim SizeY(NumForms - 1)
        
    For i = 0 To NumForms - 1
        With aFI1(i)
                Names(i) = PtrCtoVbString(.pName)
                SizeX(i) = .Size.cX
                SizeY(i) = .Size.cY
'                FormIndex = i + 1
        End With
    Next i
        PrinterDestroy
    PrinterGetForms = NumForms
End Function
Public Function PrinterFindFormName(ByVal DeviceName As String, ByVal FormIndex As Long) As String
    Dim NumForms As Long, i As Long
    Dim FI1 As FORM_INFO_1
    Dim aFI1() As FORM_INFO_1 ' Working FI1 array
    Dim temp() As Byte       ' Temp FI1 array
    Dim BytesNeeded As Long
    Dim RetVal As Long
Dim str As String
    ' Get a handle to the printer.
'    If OpenPrinter(Printer.DeviceName, PrinterHandle, 0&) Then
                PrinterCreate DeviceName


    ReDim aFI1(1)
    ' First call retrieves the BytesNeeded.
    RetVal = EnumForms(hPrinter, 1, aFI1(0), 0&, BytesNeeded, NumForms)
    ReDim temp(BytesNeeded)
    ReDim aFI1(BytesNeeded / Len(FI1))
    ' Second call actually enumerates the supported forms.
    RetVal = EnumForms(hPrinter, 1, temp(0), BytesNeeded, BytesNeeded, _
            NumForms)
    Call CopyMemory(aFI1(0), temp(0), BytesNeeded)
    For i = 0 To NumForms - 1
        With aFI1(i)
            If i + 1 = FormIndex Then
                str = PtrCtoVbString(.pName)
                Exit For
            End If
        End With
    Next i
'            ClosePrinter PrinterHandle
'    End If
            PrinterDestroy
    PrinterFindFormName = str  ' Returns non-zero when form is found.
End Function
Function PrinterDeleteForm(ByVal DeviceName As String, ByVal FormName As String) As Boolean
'    Dim PrinterHandle As Long ' Handle to printer
                        PrinterCreate DeviceName

'    If OpenPrinter(Printer.DeviceName, PrinterHandle, 0&) Then
        If DeleteForm(hPrinter, FormName) = 1 Then
            PrinterDeleteForm = True
        End If
'            ClosePrinter PrinterHandle
'    End If
            PrinterDestroy
End Function
Public Function PrinterAddNewForm(ByVal DeviceName As String, ByVal cX As Long, ByVal cY As Long, _
                           ByVal FormName As String) As String
    Dim FI1 As sFORM_INFO_1
    Dim aFI1() As Byte
    Dim RetVal As Long
'    Dim PrinterHandle As Long ' Handle to printer
    Dim cbBuf As Long, BytesNeeded As Long
    Dim FormSize As SIZEL
                        PrinterCreate DeviceName

        FormSize.cX = cX
        FormSize.cY = cY
    ' Get a handle to the printer.
'If Printers.count = 0 Then Exit Function
'    If OpenPrinter(Printer.DeviceName, PrinterHandle, 0&) Then
            ReDim aFI1(Len(FI1))
                RetVal = GetForm(hPrinter, FormName, 1, aFI1(0), UBound(aFI1), BytesNeeded)
            If BytesNeeded <> 0 Then
                ReDim aFI1(BytesNeeded)
            End If
                RetVal = GetForm(hPrinter, FormName, 1, aFI1(0), UBound(aFI1), BytesNeeded)
        If RetVal Then
            Dim Fi2 As FORM_INFO_1
            
                    Call CopyMemory(Fi2, aFI1(0), Len(Fi2))
                With Fi2
                    .flags = 0
'                    .pName = FormName
                    With .Size
                        .cX = FormSize.cX
                        .cY = FormSize.cY
                    End With
                    With .ImageableArea
'                        .Left = 0
'                        .Top = 0
                        .Right = Fi2.Size.cX
                        .Bottom = Fi2.Size.cY
                    End With
                End With
                            ReDim aFI1(Len(Fi2))
                    Call CopyMemory(aFI1(0), Fi2, Len(Fi2))
            RetVal = SetForm(hPrinter, FormName, 1, aFI1(0))
            If RetVal = 1 Then
                PrinterAddNewForm = FormName
            Else
                MsgBox "Error: " & Err.LastDllError, , "Error Updating Form"
            End If
        End If
        If RetVal = 0 Then
                With FI1
                    .flags = 0
                    .pName = FormName
                    With .Size
                        .cX = FormSize.cX
                        .cY = FormSize.cY
                    End With
                    With .ImageableArea
                        .Left = 0
                        .Top = 0
                        .Right = FI1.Size.cX
                        .Bottom = FI1.Size.cY
                    End With
                End With
                Call CopyMemory(aFI1(0), FI1, Len(FI1))
            RetVal = AddForm(hPrinter, 1, aFI1(0))
            If RetVal = 0 Then
                If Err.LastDllError = 5 Then
                    MsgBox "You do not have permissions to add a form to " & _
                            DeviceName, vbExclamation, "Access Denied!"
                Else
                    MsgBox "Error: " & Err.LastDllError, , "Error Adding Form"
                End If
                    PrinterAddNewForm = "none"
            Else
                PrinterAddNewForm = FI1.pName
            End If
        End If
'            ClosePrinter PrinterHandle
'    Else
'        PrinterAddNewForm = ""
'    End If
            PrinterDestroy
End Function
Public Function PrinterUpdateForm(ByVal DeviceName As String, ByVal cX As Long, ByVal cY As Long, _
                           ByVal FormName As String) As String
    PrinterUpdateForm = PrinterAddNewForm(DeviceName, cX, cY, FormName)
End Function
Public Function PrinterFindFormIndex(ByVal DeviceName As String, FormName As String, _
    Optional ByRef cX As Long, Optional ByRef cY As Long) As Long
    Dim NumForms As Long, i As Long
    Dim FI1 As FORM_INFO_1
    Dim aFI1() As FORM_INFO_1 ' Working FI1 array
    Dim temp() As Byte       ' Temp FI1 array
    Dim FormIndex As Integer
    Dim BytesNeeded As Long
    Dim RetVal As Long
                    PrinterCreate DeviceName

    FormIndex = 0
    ReDim aFI1(1)
    ' First call retrieves the BytesNeeded.
    RetVal = EnumForms(hPrinter, 1, aFI1(0), 0&, BytesNeeded, NumForms)
    ReDim temp(BytesNeeded)
    ReDim aFI1(BytesNeeded / Len(FI1))
    ' Second call actually enumerates the supported forms.
    RetVal = EnumForms(hPrinter, 1, temp(0), BytesNeeded, BytesNeeded, _
            NumForms)
    Call CopyMemory(aFI1(0), temp(0), BytesNeeded)
    For i = 0 To NumForms - 1
        With aFI1(i)
'            If .Size.cx = FormSize.cx And .Size.cy = FormSize.cy Then
            If FormName = PtrCtoVbString(.pName) Then
                cX = .Size.cX
                cY = .Size.cY
                ' Found the desired form
                FormIndex = i + 1
                Exit For
            End If
        End With
    Next i
            PrinterDestroy
    PrinterFindFormIndex = FormIndex  ' Returns non-zero when form is found.
End Function
Function PrinterGetFormSize(ByVal DeviceName As String, FormName As String, cX As Long, cY As Long) As Long
    Dim FI1 As sFORM_INFO_1
    Dim aFI1() As Byte
    Dim RetVal As Long
'    Dim PrinterHandle As Long ' Handle to printer
    Dim cbBuf As Long, BytesNeeded As Long
                    PrinterCreate DeviceName

            ReDim aFI1(Len(FI1))
                RetVal = GetForm(hPrinter, FormName, 1, aFI1(0), UBound(aFI1), BytesNeeded)
            If BytesNeeded <> 0 Then
                ReDim aFI1(BytesNeeded)
            End If
                RetVal = GetForm(hPrinter, FormName, 1, aFI1(0), UBound(aFI1), BytesNeeded)
        If RetVal Then
            Dim Fi2 As FORM_INFO_1
            
                    Call CopyMemory(Fi2, aFI1(0), Len(Fi2))
                With Fi2
                    With .Size
                         cX = .cX
                         cY = .cY
                    End With
                End With
        End If
            PrinterDestroy
    PrinterGetFormSize = RetVal
End Function
Public Sub PrinterPaperSources(ByVal DeviceName As String, ByVal pPort As String, Names() As String, numBin() As Integer)
    Dim dwbins As Long                  ' The number of paperbins in the printer
    Dim i As Long                       ' counter
    Dim nameslist As String             ' The string returned with all the bin names
    Dim NameBin As String               ' The parsed bin name
                'numBin Used as part of the DeviceCapabilities API call
     
        ReDim Names(0)
        ReDim numBin(0)
            PrinterCreate DeviceName
     If hPrinter <> 0 Then
         ' Get the available bin numbers
         dwbins = DeviceCapabilities(DeviceName, pPort, _
                                 DC_BINS, ByVal vbNullString, 0)
         ReDim numBin(1 To dwbins)
         ReDim Names(1 To dwbins)
         nameslist = String(24 * dwbins, 0)
         dwbins = DeviceCapabilities(DeviceName, pPort, _
                                 DC_BINS, numBin(1), 0)
         dwbins = DeviceCapabilities(DeviceName, pPort, _
                                 DC_BINNAMES, ByVal nameslist, 0)
         For i = 1 To dwbins
             ' For each bin number, add its corresponding name
             ' to our combo box
             NameBin = Mid(nameslist, 24 * (i - 1) + 1, 24)
             NameBin = Left(NameBin, InStr(1, NameBin, Chr(0)) - 1)
             Names(i) = NameBin
''                      numBin(i)
         Next i
         ' Close the printer
        PrinterDestroy
    
     End If
End Sub
